
/*
 * Copyright (c) 1997, by MCST.
 */

#ifndef	_GPIO_AC97_VAR_H
#define	_GPIO_AC97_VAR_H

/*
 * Definition of relationship between dev_t and interrupt numbers
 * instance, #intr, in/out  <=> minor
 */
#include <linux/ioctl.h>

#define LINES_NUM	8
#define LINES_MASK	((1 << LINES_NUM) - 1)

#define MAGIC_NUMBER 240

#define IOCTL_GPIO_GET_STATUS		_IO( MAGIC_NUMBER, 2)
#define IOCTL_GPIO_SET_STATUS		_IO( MAGIC_NUMBER, 3)
#define IOCTL_GPIO_WAIT_INTERRUPT	_IO( MAGIC_NUMBER, 4)

typedef struct gpio_status {
	unsigned gpio_ctrl;	// 00 set direction 0-3 -> 4-7 bit register
	unsigned gpio_data;	// 04 regiser data   0-7 bit
	unsigned gpio_int_cls;	// 08 int ctrl
	unsigned gpio_int_lvl;	// 0
	unsigned gpio_int_en;	// 10 interrupt enable
	unsigned gpio_int_sts;
} gpio_status_t;

/*
gpio_cotrol:  
               1 -    , 0 - ,
                 0x0;  RW

gpio_data:    ;    ,            
               ,   -  ;
                 0x4; ,   RW,       
              - RO

gpio_int_cls:   , 0 - , 1 - 
                 0x8;  RW

gpio_int_lvl: 0 -       
                1 -      
                ;   0x;  RW

gpio_int_en:   
               0 - 
               1 - 
                 0x10;  RW

gpio_int_sts:   ;
                  0x14;  RWC (
                 )
*/

typedef struct wait_int {
	unsigned pin;		/*      */
	unsigned timeout;	/*  */
	unsigned disable;	/*      */
} wait_int_t;


#endif				/* _GPIO_AC97_VAR_H */
