
/*   mcap_io.h:
			 - 10.02.05; home - 16.05.04 
01.02.05      .05  29.06.04			
10.02.05     .06  10.02.05
13.03.05     .07  04.03.05				
*/

/*   ,   
     */

#ifndef __LINUX_MCAP_IO_H__
#define __LINUX_MCAP_IO_H__

#ifdef	__cplusplus
extern "C" {
#endif

#include <linux/mcst/linux_me90_io.h>

/*   */
#ifdef MCAP_OLD_VERSION
#define	VERSION_MODULE_MC19		0x04030507
/*   */
#define	work_var_drv_MP			10
#else
#define VERSION_MODULE_MCAP             0x14010608
/*   */
#define work_var_drv_MP                 11
#endif /* MCAP_OLD_VERSION */
#ifdef MCAP_OLD_VERSION
#define	work_var_module			work_var_drv_MP
#else
#define	work_var_module_MCAP		work_var_drv_MP	
#endif /* MCAP_OLD_VERSION */

/*       MCAP  
      ioctl()
*/

#ifdef MCAP_OLD_VERSION
#define MCAP_IO			('M' << 8)
#define	MCAPIO_READ_DEVICE_REG			(MCAP_IO | 1)
#define	MCAPIO_WRITE_DEVICE_REG			(MCAP_IO | 2)
#define	MCAPIO_INIT_BUFERS_EXCHANGE		(MCAP_IO | 3)
#define	MCAPIO_HALT_TRANSFER_MODES		(MCAP_IO | 4)
#define	MCAPIO_GET_DEVICE_INFO			(MCAP_IO | 5)
#define	MCAPIO_INTR_TIME_WAIT			(MCAP_IO | 6)
#define	MCAPIO_MESSAGE_NOTE			(MCAP_IO | 7)

#define MCAP_CNTR_ST_REG_SET_OFFSET		0x10000 /*    */
#define MCAP_CNTR_ST_REG_SET_LEN       		0x100	/*    */
#define	MCAP_BMEM_REG_SET_OFFSET		0x40000 /*    */
#define	MCAP_BMEM_REG_SET_LEN			0x20000 /*     */
#define MCAP_DRV_CMN_AREA_BMEM_ADDR		0x01990	/*    */
							/*    */
#define MCAP_AREA_BMEM_ADDR			0xD0	/*    */
							/*  */
#else
#define MCAP_IO                 ('M' << 8)
#define MCAPIO_LOAD_MP_DRV_CODE                 (MCAP_IO | 1)
#define MCAPIO_STARTUP_MP_DRV                   (MCAP_IO | 2)
#define MCAPIO_STARTUP_MP_ROM_DRV               (MCAP_IO | 3)
#define MCAPIO_RESET_MP                         (MCAP_IO | 4)
#define MCAPIO_GET_DRIVER_INFO                  (MCAP_IO | 5)
/************************************************************************/
#define MCAPIO_READ_DEVICE_REG                  (MCAP_IO | 6)
#define MCAPIO_WRITE_DEVICE_REG                 (MCAP_IO | 7)
#define MCAPIO_INIT_BUFERS_EXCHANGE             (MCAP_IO | 8)
#define MCAPIO_HALT_TRANSFER_MODES              (MCAP_IO | 9)
#define MCAPIO_GET_DEVICE_INFO                  (MCAP_IO | 10)
#define MCAPIO_INTR_TIME_WAIT                   (MCAP_IO | 11)
#define MCAPIO_MESSAGE_NOTE                     (MCAP_IO | 12)
/************************************************************************/
#define MCAPIO_NUM_INTR_ROSH                    (MCAP_IO | 13)
                                                                                                              
#define MCAP_ROOT_E90_NAME                      "ROOT_E90"
#define MCAP_MP_INIT_DEFAULT_CODE       	{0xfaea0000, 0x00000000}
                                                /* CLI JUMP, JUMP_address end */
#define MCAP_MP_INIT_JUMP_ADDR_OFF              2
#define MCAP_MP_INIT_AREA_BMEM_ADDR             0x1fff0
/************************************************************************/
#define MCAP_BMEM_REG_SET_OFFSET                0x40000 /*    */
#define MCAP_BMEM_REG_SET_LEN                   0x20000 /*    */
/************************************************************************/
#define MCAP_DRV_CMN_AREA_BMEM_ADDR     	0x01990 /*    */
                                                        /*    */
#define MCAP_AREA_BMEM_ADDR                     0xD0    /*    */
                                                        /*  */
#endif /* MCAP_OLD_VERSION */


/* 
     ,   (   -)
        ioctl()
   (   drv_error_code     
   )
*/

#define FINISH_TRANS       1 /*      */
#define START_RECIV        2 /*       */
#define FINISH_RECIV       3 /*       */

#define	BCW_HARDWARE_MCAP_ERROR		12

/*   */
#define NO_ERROR                 0 /*   () */
#define ERROR_INIT_BUFFERS       0x01 /*     */
									  /*    */
#define ERROR_PLACE_MODE_MNIR    0x02 /*     */
									  /*    */
#define ERROR_PLACE_MODE_BATTLE  0x04 /*     */
									  /*    */
#define ERROR_HALT_CHANNEL       0x08 /*    () */
#define FAILURE_TRANS         	 0x10 /*       */
#define FAILURE_RECIV		 0x20 /*       */

 /*      */
#define bit_trns		0xFC /*       */
#define err_trns		0x0C /*      */

#define sig_warning		0x80 /*    */
#define trans_word		0x40 /*      */
#define user_data_tr		0x20 /*    -  */
#define end_array_tr		0x10 /*      */
				     /*   */
#define sign_pbozy_tr		0x08 /*   ABOZU */
#define false			0x04 /*       */
#ifdef MCAP_OLD_VERSION
#define not_trans_2		0x02 /*  */
#else
#define congestion_prd  	0x02 /*     */
#endif /* MCAP_OLD_VERSION */
#define not_trans_1	    	0x01 /*  */

/*      */
#define bit_rcv			0xFE /*       */
#define err_rcv			0x6A /*      */

#define end_array_rv		0x80 /*      */
							 /*   */
#define sign_pbozy_rv		0x40 /*   ABOZU */
#define busy_buf		0x20 /*      */
#define reaciv_word		0x10 /*    */
#define no_tfr			0x08 /*     */
#define user_data_rv		0x04 /*    -  */
#define mod_err			0x02 /*       mod3 */
#define not_reciv		0x01 /*  */

#define	MCAP_SUBDEV_BUF_NUM		4 	/* -   () */
#define	PACKET_FREQUENCY		0x0200	/*       */
#define	CONSTANT_FREQUENCY		0 	/*       */
#define	MCAP_HUNGUP_TIMER_INTERVAL	360000
									/*    */
									/*    */
									/* ( ) */

#define	MCAP_NOT_CHANGE		 0	/*   */
#define	MCAP_IO_WRITE		 0x01	/*  (  ) */
#define	MCAP_IO_READ		 0x02	/*  (  ) */
#define	MCAP_WRITE_READ		 0x03	/* / */

#define	GISTOGR			   8   	/*     */
/*   19 */
#define	MODE_COUPLED		   1   	/*       */
				       	/*     */
				       	/*  */
#define	MODE_COUPLED_COMPUTERS 0x0400 

#define	MODE_STANDBY		   2	/*       */
					/*    */
#define	MODE_STANDBY_COMPUTER  0x0100

#define	MODE_SINGLE		   3	/*       */
					/*      */
#define	MODE_SINGLE_COMPUTER   0x0600

#define	AFM   			   4	/*  , -   */
#define	MODE_AFM	       0x0700 
#define	MODE_US19   		   5	/*     19 */
#define	AUDIT_TE	   	   6 	/*     */

#define	NOT_RESTORE   		   0	/*   ,   0 */
#define	RESTORE  	           1	/*  ,   0  */

#define	NOT_EXCHANGE_DATAS	   0	/*       */
					/*      */
#define	EXCHANGE_DATAS         	   1	/*       */
					/*     */
#define	NOT_PRODUCE_INTR	   0	/*      */
					/*  */
#define	PRODUCE_INTR           	   1	/*      */

#define	MCAP_DMA_BURST_SIZE	   8*4	/*  ( )   */

#ifdef MCAP_OLD_VERSION
#define	MCAP_MAX_NUM_WORD	0xFFF
#define	MCAP_MAX_WORD_DATA_BUF_TRANS	256 	/*         */
#define	MCAP_MAX_WORD_DATA_BUF_RECIV	3568 	/*        */
#else
#define MCAP_MAX_WORD_DATA_BUF_TRANS    4088    /*         */
#define MCAP_MAX_WORD_DATA_BUF_RECIV    4095    /*        */
#endif /* MCAP_OLD_VERSION */
#define	MCAP_MAX_DATA_BUF_SIZE		MCAP_MAX_WORD_DATA_BUF_RECIV*4	/*     */
									/*     */
/*       */
/*        */
#define ERRORVERDRVVK		164


/*	        
	       DMA.
	nelem -     
	elsize -    
	off -         
	bsize -      DMA
	 -       
	 MCAP_DMA_BURST_SIZE */

#define	TU_MCAP_DMA_BURST_SIZE_ALIGN(nelem, elsize, off, bsize) ((((((nelem) * \
		(elsize) + (off) + ((bsize)-1)) / (bsize)) * (bsize)) \
		- (off)) / (elsize))

 /*      MCAP   .  
 	 .         - 
 	  .        
 	,  ,      
	       .
	       , 
	 :
						  ____________________________________
	 mcap_iosubd_desc -> |             |
						 |      (         |
						 |        )        |
						 |----------------------------------|
	 mcap_data_buf    -> |      ,         |
						 |             |
						 |                      |
						 |__________________________________|

	          ,
	   ,       
	     - 8  (32 ),  
	          
	  (DMA).  ,
	      ,    .
	          -
	    (.    ).
	            
	   ,    
	       'open_mcap_drv.h'.
	       ,    
	,        
	 (  MCAP,  ). 
	       ,
	  ,        
	   .      
	.      
	 -     .   
	     
	'mcap_iosubdbuf_t'  ,    
	'MCAP_MAX_DATA_BUF_SIZE'   ,  
	   .    
	        
	()  -     (. 
	 ,          
	).
*/

/*     (  ), 
	      MCAP    
	  ,      , .. 
	  .
		       
	,        
	 - 8  (32 ),       
	        (DMA).
	       8   .
	         
	  .
		         
	   .
	        
	    .
	      
	       :
	transfer_completed
	  - ,   .
*/
#ifdef MY_DRIVER_BIG_ENDIAN
typedef union reg_general_mcap
{
	u_int          rdwr_reg_general;
	struct
		{
			u_int  bit3129 : 3; /*   */
			u_int  bit2824 : 5; /*  - RNKSH */
			u_int  bit2321 : 3; /*   */
			u_int  bit2016 : 5; /*  - ROSH */
			u_int  bit1507 : 9; /*   */
			u_int  bit06   : 1; /*  - TPCHSH */
			u_int  bit05   : 1; /*  - TSZ */
			u_int  bit04   : 1; /*  - TPSH */
			u_int  bit03   : 1; /*  - TBL */
			u_int  bit02   : 1; /*  - TSM */
			u_int  bit0100 : 2; /*   */
		} as_bits_0;
} reg_general_mcap_t;
#else
typedef union reg_general_mcap
{
	u_int          rdwr_reg_general;
	struct
		{
			u_int  bit0100 : 2; /*   */
			u_int  bit02   : 1; /*  - TSM */
			u_int  bit03   : 1; /*  - TBL */
			u_int  bit04   : 1; /*  - TPSH */
			u_int  bit05   : 1; /*  - TSZ */
			u_int  bit06   : 1; /*  - TPCHSH */
			u_int  bit1507 : 9; /*   */
			u_int  bit2016 : 5; /*  - ROSH */
			u_int  bit2321 : 3; /*   */
			u_int  bit2824 : 5; /*  - RNKSH */
			u_int  bit3129 : 3; /*   */
		} as_bits_0;
} reg_general_mcap_t;
#endif /* MY_DRIVER_BIG_ENDIAN */

#define	reg_RNKSH		as_bits_0.bit2824 	/*  - RNKSH */
#define	reg_ROSH		as_bits_0.bit2016 	/*  - ROSH */
#define	trg_TPCHSH		as_bits_0.bit06 	/*  - TPCHSH */
#define	trg_TSZ			as_bits_0.bit05 	/*  - TSZ */
#define	trg_TPSH		as_bits_0.bit04 	/*  - TPSH */
#define	trg_TBL			as_bits_0.bit03 	/*  - TBL */
#define	trg_TSM			as_bits_0.bit02 	/*  - TSM */

#define MCAP_TSM       	0x08 /*    */
#define MCAP_TBL       	0x0C /*    */
#define MCAP_TPSH      	0x10 /*     */
#define MCAP_TSZ      	0x14 /*      */
#define MCAP_TPCHSH     0x18 /*      */
#define MCAP_RERR     	0x1C /* ROSH       */
#define MCAP_TZM       	0x20 /*    */

/* /   MCAP */
typedef struct arg_reg {
	int		reg_addr;	/*   */
	u_short		reg_value;	/* /  */
} mcap_arg_reg_t;

typedef struct mcap_iosubd_desc {
	u_short	transfer_completed;     /*    */
	u_short	channel_check_word;	/*   ( ) */
	u_short	data_size_exchange; 	/*    */
	u_short	first_error; 	 	/*  ,   () */
					/*     */
					/*  */
	u_short	num_error; 	 	/*    */
	u_short exchange_error_code;    /*  ,   M */
	u_short signal_adapter;         /* -   () */
	u_short	cur_ease_code;          /*  -   */
	short	buf_num;        	/*    */
	u_short io_flags; 		/*    */
	u_short	data_size; 		/*       */
	short	unused2; 		/*   */
	int	unused_word6; 		/*   */
	int	unused_word7; 		/*   */
} mcap_iosubd_desc_t;

/*	    .
	          
	      .
	      
	  
*/
typedef union mcap_data_buf_ {
	u_short
								/*     */
								/*     MCAP */
								/* (2 , 16 ) */
		words[TU_MCAP_DMA_BURST_SIZE_ALIGN(MCAP_MAX_DATA_BUF_SIZE /
				sizeof(u_short),
			sizeof(u_short), 0, MCAP_DMA_BURST_SIZE)];
	u_int
								/*    */
								/*  (4  32 ) */
		longs[TU_MCAP_DMA_BURST_SIZE_ALIGN(MCAP_MAX_DATA_BUF_SIZE /
			sizeof(u_int), sizeof(u_int), 0,
			MCAP_DMA_BURST_SIZE)];
	u_char
								/*   */
		bytes[TU_MCAP_DMA_BURST_SIZE_ALIGN(MCAP_MAX_DATA_BUF_SIZE,
			sizeof(u_char), 0, MCAP_DMA_BURST_SIZE)]; 
} mcap_data_buf_t;

/*     .
	    
	      .   
	   	      
	 .      .
*/
typedef struct mcap_iosubdbuf {
	mcap_iosubd_desc_t
			buf_desc;  /*     */
	mcap_data_buf_t
			data_buf;  /*        */
} mcap_iosubdbuf_t;

/*      .
	      
	     .
*/
typedef struct mcap_iomap_subd {
	mcap_iosubdbuf_t	write;  /*   */
	mcap_iosubdbuf_t	read;	/*   */

} mcap_iomap_subd_t;

/*     -    .
	      
	      .
*/
typedef mcap_iomap_subd_t		mcap_iomap_t;

/*        */
typedef struct mcap_init_iomap {
	u_short	buf_num;			/*     */
	u_short	max_data_buf_trans_size;	/*      */
	u_short	max_data_buf_reciv_size;	/*      */
	size_t		*real_buf_size_p;
								/*    */
								/*    */
								/*    */
								/*  c  */
								/*   */
								/*   */
	int		*error_code_p;				/*    */
								/*    , */
								/*    */
								/*    */
								/*  */
} mcap_init_iomap_t;


/*         */
#ifdef MCAP_OLD_VERSION
typedef struct mcap_halt_trans {
	int		waiting_time;				/*    */
								/*    */
								/*  ,  */
								/*    */
								/*   */
								/*  0,    */
								/*     */
								/*   */
								/*    - */
								/* ( close() ) */
								/*  < 0,   */
								/*     */
								/*    */
								/*    */
								/*    */
								/*   */
								/*  > 0,     */
								/* ,  */
								/*     */
								/*   */
} mcap_halt_trans_t;
#else
typedef struct mcap_halt_trans {
        int             flag_close;             		/*  = 1,     , */
                                                        	/*      */
                                                        	/*      */
} mcap_halt_trans_t;
#endif /* MCAP_OLD_VERSION */

/*  ,       
     .
         ,  
    ioctl() 
*/
typedef	struct mcap_dev_info {
	int			instance;	/*  MCAP */
	int			channel;	/*   */
} mcap_dev_info_t;

#ifdef MCAP_OLD_VERSION
typedef struct mcap_drv_info
{
	int			sbus_clock_freq;	/*   SBus */
	int			sbus_nsec_cycle;	/*   tick- SBus */
	int			mp_clock_freq;		/*   SBus */
							/*  */
	int			mp_nsec_cycle;		/*   tick-  */
	e90_unit_t		device_type;		/*   */
	int			mp_rom_drv_enable;	/*    */
	hrtime_t    		cur_hr_time;		/*     */
}	mcap_drv_info_t;
#else
typedef struct mcap_drv_info
{
        int                     sbus_clock_freq;        /*   SBus */
        int                     sbus_nsec_cycle;        /*   tick- SBus */
        int                     mp_clock_freq;          /*   SBus */
                                                        /*  */
        int                     mp_nsec_cycle;          /*   tick-  */
        int                     mp_rom_drv_enable;      /*    */
        hrtime_t    		cur_hr_time;            /*     */
}       mcap_drv_info_t;

typedef struct mcap_bmem_trans_desk
{
        caddr_t      mem_address;               /* SPARC memory address */
        caddr_t      mp_bmem_address;   	/* MP base memory address */
        size_t       byte_size;                 /* byte size of loaded code */
 }      mcap_bmem_trans_desk_t;

#endif /* MCAP_OLD_VERSION */

/* ,     MCAPIO_INTR_TIME_WAIT */
#ifdef MCAP_OLD_VERSION
typedef struct mcap_intr_wait {
	u_long	intr_wait_time;			/*    () */
	u_short	event_intr;			/*   */
	u_short	event_intr_trans[MCAP_SUBDEV_BUF_NUM];	/*     */
	u_short	event_intr_reciv[MCAP_SUBDEV_BUF_NUM];	/*     */
	hrtime_t	time_get_intr_device; 		/*      */
} mcap_intr_wait_t;
#else
typedef struct mcap_intr_wait {
        u_long  intr_wait_time;                 /*    () */
        u_short event_intr;                     /*   */
        u_short event_intr_trans[MCAP_SUBDEV_BUF_NUM];   /*     */
        u_short event_intr_reciv[MCAP_SUBDEV_BUF_NUM];   /*   ɣ  */
        hrtime_t        time_get_intr_device; 		 /*      */
        u_short         num_intr_rosh;  		 /* -    */
} mcap_intr_wait_t;
#endif /* MCAP_OLD_VERSION */

/* ,         */
/*     */
typedef struct user_inform_trans_ch {
	u_short		trans_error_code;  	/*  ,   M */
	u_short		word_state_channel; 	/*   ( ) */
	u_short		num_zok_channel;    	/* -  */
} get_user_inform_trans_channel_t;

/* ,       */
typedef struct user_inform_state_ch {
	u_short	word_state_trans_ch; 		/*    */
						/*   ( ) */
	u_short	number_trans_words;  		/*  ,    */
	u_short	word_state_reciv_ch; 		/*    */
						/*   ( ) */
	u_short	number_reciv_words;  		/*      */
						/*    */
						/*    */
	u_short	checked_error_code;  		/*  ,   M */
	u_short	num_zok;  			/* - ,   */
	u_short	num_ini;  			/* - ,   */
} get_user_inform_state_channel_t;

/* ,     */
typedef struct inform_of_chs {
/*  -     */
	u_short		cur_num_ecode_trans[MCAP_SUBDEV_BUF_NUM];
/*  -     */
	u_short		cur_num_ecode_reciv[MCAP_SUBDEV_BUF_NUM];
/*  -    */
	u_short		cur_num_trans_word[MCAP_SUBDEV_BUF_NUM];
/*  -    */
	u_short		cur_num_reciv_word[MCAP_SUBDEV_BUF_NUM];
/*      */
	u_short		cur_num_accept_packet[MCAP_SUBDEV_BUF_NUM];
/* C -        */
	u_short		amount_ease_code[MCAP_SUBDEV_BUF_NUM];
/*     */
	u_short		cur_pointer_reciv[MCAP_SUBDEV_BUF_NUM];
} get_user_inform_of_chs_t;

#ifndef MCAP_OLD_VERSION
typedef struct mcap_rezult_reciv {
        u_short amount_code_secrete;    /* -    */
        u_short escape_index_write;     /*       */
        u_short indent_data_size;       /*    */
        u_short real_data_size;         /*  -   */
        u_short not_process_word;       /* -      */
        u_short channel_check_word;     /*   ( ) */
        u_short first_error;            /*  ,   (ɣ) */
                                        /*     */
                                        /*  */
        u_short num_error;              /*    */
        u_short exchange_error_code;    /*  ,   M */
        u_short signal_adapter;         /* -   */
        u_short cur_ease_code;          /*  -   */
        u_short n_process;              /* -   */
        u_short n_read;                 /* -    */
} mcap_rezult_reciv_t;

#endif /* MCAP_OLD_VERSION */

/* ,       */
/*    */
typedef struct user_inform_turn_off_ch {
	u_short	turn_error;  	/*  ,   M */
} get_user_inform_turn_off_ch_t;

/*     */
typedef struct delivery_note_message
{
	char		code_msg[128];		/*   */
	char		name_user[32];		/*   */
} delivery_note_message_t;

#ifndef MCAP_OLD_VERSION
/*       */
typedef struct intr_rosh
{
        u_short         num_intr_rosh;  /* -    */
} mcap_intr_rosh_t;
#endif /* MCAP_OLD_VERSION */

/*    */
typedef struct buf_data {
	u_int	area_subbuf0[16];
	u_int	area_subbuf1[16];
} buf_data_t;

/*     */
typedef struct buf_args {
	u_int	USK; /*  */
	u_int	AC0; /* 0 */
	u_int	SKB; /*  */
	u_int	AC1; /* 1 */
} buf_args_t;

/*      */
typedef struct mcap_area_bozu {
	u_int		val_reg[40]; 			/*     */
	u_int		val_arg[24]; 			/*   */
	u_int		var_prog[76]; 			/*    */
	u_int		mac_stat_mp[67]; 		/*   */
	u_int		bd_stat_drv[765]; 		/*    */
	buf_data_t  	buf_data[MCAP_SUBDEV_BUF_NUM*4];/*     */
	buf_args_t  	init_buf_data[MCAP_SUBDEV_BUF_NUM*4];	/*      */
	buf_data_t  	buf_mp;				/*    */
	buf_args_t  	init_buf_mp;			/*     */
	u_int		task[36]; /*     */
	u_int		answer[16]; /*     */
	u_int		flag_drv; /*    */
	u_int		ANSWER_INTR[2]; /*    */
	u_int		flag_intr; /*      */
} mcap_area_bozu_t;

#ifdef	__cplusplus
}
#endif

#endif	/* __LINUX_MCAP_IO_H__ */
