
/*
 * Copyright (c) 1997-2000 by MCST.
 */

/*
 * Defines and structures used by both the driver
 * and user application
 */

#ifndef __LINUX_MCPM_IO_H__
#define __LINUX_MCPM_IO_H__

#ifdef	__cplusplus
extern "C" {
#endif

#include <sys/types.h>

#include <linux/mcst/define.h>
#include <linux/mcst/linux_me90_io.h>


/*
 * Commands for 'ioctl' entry of mcb driver
 *       MCPM  
 *    ioctl()
 */

#define MCPM_IO			('M' << 8)

#define	MCPMIO_LOAD_MP_DRV_CODE			ME90IO_LOAD_MP_DRV_CODE
#define	MCPMIO_STARTUP_MP_DRV			ME90IO_STARTUP_MP_DRV
#define	MCPMIO_STARTUP_MP_ROM_DRV		ME90IO_STARTUP_MP_ROM_DRV
#define	MCPMIO_SPECIFIED_TRANSFER		(MCPM_IO | 3)
#define	MCPMIO_RESET_MP				ME90IO_RESET_MP
#define	MCPMIO_BATCH_TRANSFER			(MCPM_IO | 5)
#define	MCPMIO_SET_INTR_MODE			(MCPM_IO | 6)
#define	MCPMIO_RESET_INTR_MODE			(MCPM_IO | 7)
#define	MCPMIO_GET_DRIVER_INFO			ME90IO_GET_DRIVER_INFO
#define	MCPMIO_LOCK_RESET_MODULE_ON_ERROR		\
		ME90IO_LOCK_RESET_MODULE_ON_ERROR
#define	MCPMIO_UNLOCK_RESET_MODULE_ON_ERROR		\
		ME90IO_UNLOCK_RESET_MODULE_ON_ERROR
#define	MCPMIO_WAIT_FOR_TRANSFER_IN_PROGRESS		\
		ME90IO_WAIT_FOR_TRANSFER_IN_PROGRESS
#define	MCPMIO_STARTUP_MP_CODE			ME90IO_STARTUP_MP_CODE
#define	MCPMIO_SET_MP_STATE			ME90IO_SET_MP_STATE
#define	MCPMIO_SET_COMMON_BUF_MAPING_MODE	(MCPM_IO | 15)
#define	MCPMIO_RESET_COMMON_BUF_MAPING_MODE	(MCPM_IO | 16)
#define	MCPMIO_SUBDEV_MAP_TRANSFER		(MCPM_IO | 17)
#define	MCPMIO_OUT_LAST_TRANS_STATE		ME90IO_OUT_LAST_TRANS_STATE
#define	MCPMIO_GET_DRIVER_TRACE_MSG		ME90IO_GET_DRIVER_TRACE_MSG
#define	MCPMIO_RESTART_BOARD			ME90IO_RESTART_BOARD
#define	MCPMIO_INIT_TRANSFER_MODES		(MCPM_IO | 21)
#define	MCPMIO_HALT_TRANSFER_MODES		(MCPM_IO | 22)
#define	MCPMIO_INIT_BATCH_TRANSFER_MODES	(MCPM_IO | 23)
#define	MCPMIO_WRITE_DEV_ADAPTER_REG		ME90IO_WRITE_DEV_ADAPTER_REG
#define	MCPMIO_READ_DEV_ADAPTER_REG		ME90IO_READ_DEV_ADAPTER_REG
#define	MCPMIO_GET_DEVICE_INFO			(MCPM_IO | 26)
#define	MCPMIO_SET_DRV_GENERAL_MODE		ME90IO_SET_DRV_GENERAL_MODE
#define	MCPMIO_RESET_DRV_GENERAL_MODE		ME90IO_RESET_DRV_GENERAL_MODE
#define	MCPMIO_GET_DRV_GENERAL_MODES		ME90IO_GET_DRV_GENERAL_MODES
#define	MCPMIO_PUT_DRV_GENERAL_MODES		ME90IO_PUT_DRV_GENERAL_MODES
#define	MCPMIO_WAIT_FOR_ASYNC_TRANS_END		ME90IO_WAIT_FOR_ASYNC_TRANS_END
#define	MCPMIO_CHECK_RESTART_BOARD		ME90IO_CHECK_RESTART_BOARD
#define	MCPMIO_START_RESTART_BOARD		ME90IO_START_RESTART_BOARD
#define	MCPMIO_CONTINUE_RESTART_BOARD		ME90IO_CONTINUE_RESTART_BOARD

/*
 *  I/O operation mode flags
 *        
 */

#define	DMA_TRANSFER_IO_MODE		0x0002	/* DMA transfer */
						/*    DMA */
#define	BMEM_TRANSFER_IO_MODE		0x0004	/* transfer BMEM <-> SPARC */
						/* only test mode usege */
						/*    : */
						/*    */
						/*  <->   */
						/*  (   */
						/* ) */

/*
 *  Map of error code detected by MP driver (mp_error_code field of ioctl
 *  commands)
 *       (   -) 
 *      ioctl()
 *  (   drv_error_code     
 *  )
 */

#define	DEV_NOT_RESPOND_MCPM_ERROR	1
#define	SUBDEV_NOT_SET_MCPM_ERROR	2

#define   MCPM_REPEAT_INIT     		1
#define   MCPM_ILLEG_CHAN      		2
#define   MCPM_ILLEG_STATUS    		3
#define   MCPM_ILLEG_CTRL_B    		4
#define   MCPM_ILLEG_TERM_A    		5
#define   MCPM_ILLEG_SUBADR    		6
#define   MCPM_REGIM_ERROR     		7
#define   MCPM_NOT_INIT        		8
#define   MCPM_ILLEG_COM       		9
#define   MCPM_ILLEG_MSG_SIZE  		10
#define   MCPM_REPEAT_EXCH     		11
#define   BCW_HARDWARE_MCPM_ERROR	12
#define   MCPM_SP_BZ_FORB      		13
#define   MCPM_LOOK_ROSH       		14
#define   MCPM_ILLEG_PACKET    		15
#define   MCPM_LOOK_VSK_CTL    		16
#define   MCPM_CRASH_TIMER     		17
#define   MCPM_ILLEG_BUF       		18
#define   PACKET_MCPM_ERROR    		19
#define   MCPM_CRASH_ABORT     		20
#define   MCPM_CRASH_TIMER_CTL 		21
#define   MCPM_EXCH_END_NOT    		22
#define   MCPM_TACT_350_NOT    		23
#define   MCPM_SUSPEND         		24 

#define	BAD_PACKETS_NUM_MCPM_ERROR	0x22
#define	CANCELED_MCPM_ERROR		0x23

/*
 *  Types of I/O transfer error codes
 *        
 */

typedef	u_char		mcpm_drv_err_t;		/* code of error detected by */
						/* MCPM driver */
						/*     */
						/*   */
						/*   */
						/* ( ) */
typedef	u_short		mcpm_bcw_t;		/* built-in check word of */
						/* MCPM hardware (channel */
						/* adapter errors) */
						/*    */
						/*   */
						/*   */
						/* ( ) */

/*
 *  packet and batch of packets types specifications
 *         MCPM
 */

typedef	u_char		mcpm_io_op_t;		/* I/O operation flags */
						/*    */
typedef	u_char		mcpm_iodev_num_t;	/* MCPM device number */
						/*    */
						/*    */
typedef	u_short		mcpm_io_word_t;		/* word of data buffer */
						/*    */
						/*   */
typedef	u_char		mcpm_io_size_t;		/* data buffer size */
						/*     */
						/*  */
typedef	u_char		mcpm_adp_mode_t;	/* MCPM channel adapter */
						/* control-state mode bits */
						/*   */
						/*    */
						/*   */

/*
 *  Device number and I/O operation flags description
 *     ,  ,   
 *        .
 *          31.
 */

typedef struct mcpm_dev_num
{
	mcpm_iodev_num_t	main_addr;	/* main address of device */
						/*    */
	mcpm_iodev_num_t	sub_addr;	/* subaddress of device */
						/*   */
} mcpm_dev_num_t;

#define	MCPM_MIN_DEVICE_NUM			0
#define	MCPM_MAX_DEVICE_NUM			31
#define	MCPM_MIN_SUBDEVICE_NUM			1
#define	MCPM_MAX_SUBDEVICE_NUM			30

/*
 *   (    )
 *  'MCPM_ERRORS_SUBDEVICE_NUM'     .
 *        ,  
 *             -
 *   .
 */

#define	MCPM_ERRORS_SUBDEVICE_NUM		0

/*
 *  MCPM I/O operation encoding (mcpm_io_op_t and mcpm_iopack_op_t)
 *      MCPM (mcpm_io_op_t & mcpm_iopack_op_t)
 */

#define	MCPM_IO_WRITE	0x1			/* write operation */
						/*  (  ) */
#define	MCPM_IO_READ	0x2			/* read operation */
						/*  (  ) */

/*
 *  Channel Control word structure description
 *        
 *         
 *   .
 */

typedef struct mcpm_ccw
{
	mcpm_io_word_t	main_addr	:  5;	/* [15:11] device address  */
						/*    */
						/*  c   */
	mcpm_io_word_t	write_flag	:  1;	/* [10] write I/O operation  */
						/* flags */
						/*     */
						/*  0 -    */
						/*  */
	mcpm_io_word_t	sub_addr	:  5;	/* [ 9: 5] subaddress of */
						/* device */
						/*  , */
						/*  c   */
	mcpm_io_word_t	word_size	:  5;	/* [ 4: 0] word size of */
						/* transfer */
						/*     */
						/*  (16 ) */
} mcpm_ccw_t;

/*
 *  MCPM-controller I/O operation packet and batch of packets specifications
 *           
 *     (   )
 */

/*
 *  MCPM I/O operation batch of packets specifications. The batch is common
 *  structure and comprises descriptors of packets, data buffers and I/O
 *  operation results area for each packet. Descriptors of packets are the
 *  first item of the batch and other allocated with fixed offset into batch,
 *  including all packets I/O data buffers
 *    MCPM       ,
 *             
 *    .
 *          :
 *       batch_desc      -      
 *                              ;
 *       packets         -   ,  
 *                              ;
 *       data_bufs       -     ;
 *       private_area    -     
 *                           .
 *          ,   
 *   .        
 *       ,  
 *           
 *           
 *   (DMA).
 *     (    , 
 *    ,     )  
 *    "#define'     ,    
 *  .       (. )
 *         
 *    ;
 *   ,          
 *   ,        
 *       :
 *
 *                      ____________________________________
 *   batch_desc     ->  |                  |
 *                      |       |
 *                      |----------------------------------|
 *   packets        ->  |    0-     |
 *                      |----------------------------------|
 *                      |    1-     |
 *                      |----------------------------------|
 *                      |   ............................   |
 *                      |__________________________________|
 *                      |        |
 *                      |----------------------------------|
 *                      |   ............................   |
 *                      |   ............................   |
 *                      |   ............................   |
 *                      |__________________________________|
 *   data_bufs      ->  |       0-      |
 *                      |                                  |
 *                      |                                  |
 *                      |                                  |
 *                      |----------------------------------|
 *                      |       1-      |
 *                      |                                  |
 *                      |                                  |
 *                      |                                  |
 *                      |----------------------------------|
 *                      |   ............................   |
 *                      |   ............................   |
 *                      |   ............................   |
 *                      |__________________________________|
 *                      |       |
 *                      |                                  |
 *                      |                                  |
 *                      |                                  |
 *                      |----------------------------------|
 *                      |   ............................   |
 *                      |   ............................   |
 *                      |   ............................   |
 *                      |----------------------------------|
 *   private_area   ->  |        |
 *			|        0-           |
 *                      |----------------------------------|
 *                      |        |
 *			|        1-           |
 *                      |----------------------------------|
 *                      |   ............................   |
 *                      |__________________________________|
 *                      |        |
 *			|             |
 *                      |----------------------------------|
 *                      |   ............................   |
 *                      |   ............................   |
 *                      |   ............................   |
 *                      |__________________________________|
 *
 *              
 *          
 *          
 *      .      
 *         (.   
 *   ).
 *            
 *     ,        
 *   .       
 *   (  350  1750).    
 *   .       
 *      .      
 *      .
 *              
 *          
 *   .        
 *  ,        .
 *           
 *     .    
 *    ,     ,
 *       .
 *                      :
 *               
 *            DMA.
 *                        :
 *            ,  
 *           
 *    (.    ).
 *             
 *     (  MCPM,  ). 
 *        , 
 *  ,          
 *   .       
 *   'mcpm_iobatch_t'  ,    
 *  'MCPM_MAX_PACKETS_NUM'     'MCPM_MAX_DATA_BUF_SIZE'
 *         
 *  .         
 *   ,      
 *    ,     . 
 *       
 *      .
 *            
 *   , .,     ,
 *    0-,  1-     .   
 *       1750  ,   
 *   .    1750     
 *  .         
 *    'open_mkb_drv.h'.    
 *            .
 *            
 *  1750,  ,  ,    
 *      , ..   350  1750.
 */

/*
 *  Default value of MCPM batch specifications
 *           
 *            MCPM
 *        MCPM   
 *    ,        
 *     (.    )
 *       ,   
 *           DMA    
 *       ,    
 *       .
 */

#define	MCPM_MAX_PACKETS_NUM_DEF	2	/* default value of MCPM max */
						/* number of packets in */
						/* I/O operations batch */
						/*    */
						/*     */
						/*     */

#define	MCPM_DMA_BURST_SIZE_DEF		32	/* default value of MCPM DMA */
						/* burst size for I/O */
						/* operations  */
						/*  ( )  */
						/*     */
						/*    */
						/*   */
						/* (DMA)   */

#define	MCPM_MAX_DATA_BUF_SIZE_DEF	64	/* default value of MCPM max */
						/* size of I/O data buffer */
						/*     */
						/*    */
						/*    */
						/*     */

#define	MCPM_SUBCLOCKS_NUM		5	/* number of subclocks in */
						/* main clock */
						/*   350 */
						/*    */
						/*  1750 */

/*
 *  Value of MCPM batch main specifications
 *          
 *           MCPM.
 *          
 *     (..  #include "mcpm_io.h"),   
 *  ,     .
 *           
 *           (. ),
 *           
 *      (.    ).
 *       ,   
 *           DMA    
 *       ,    
 *       .
 */

#ifndef	MCPM_MAX_PACKETS_NUM
#define	MCPM_MAX_PACKETS_NUM		MCPM_MAX_PACKETS_NUM_DEF
#endif	/* MCPM_MAX_PACKETS_NUM */

#ifndef	MCPM_DMA_BURST_SIZE
#define	MCPM_DMA_BURST_SIZE		MCPM_DMA_BURST_SIZE_DEF
#endif	/* MCPM_DMA_BURST_SIZE */

#ifndef	MCPM_MAX_DATA_BUF_SIZE
#define	MCPM_MAX_DATA_BUF_SIZE		MCPM_MAX_DATA_BUF_SIZE_DEF
#endif	/* MCPM_MAX_DATA_BUF_SIZE */

/*
 *  Convert array of structure elements num to be an even multiple
 *  of alignment of DMA burst size MCPM_DMA_BURST_SIZE
 *          
 *         DMA.
 *  nelem -     
 *  elsize -    
 *  off -         
 *  bsize -      DMA
 *   -       
 *               MCPM_DMA_BURST_SIZE
 */

#define	TO_MCPM_DMA_BURST_SIZE_ALIGN(nelem, elsize, off, bsize) ((((((nelem) * \
		(elsize) + (off) + ((bsize)-1)) / (bsize)) * (bsize)) \
		- (off)) / (elsize))

/*
 *  packet and batch of packets types specifications
 *         
 *    
 */

typedef	char		mcpm_iopack_num_t;	/* number of MCPM packets */
						/*     */
typedef	mcpm_io_op_t	mcpm_iopack_op_t;	/* I/O operation flags */
						/*    */
typedef	mcpm_io_word_t	mcpm_iopack_word_t;	/* word of packet data buffer */
						/*    */
						/*    */
typedef	mcpm_io_size_t	mcpm_iopack_size_t;	/* packet data buffer size */
						/*     */
						/*    */
typedef	u_char		mcpm_iopack_clock_t;	/* clock number (T350) of */
						/* MCPM packets */
						/*   350 */
						/*     */
						/*    */

/*
 *  Descriptor of batch of packets of I/O data transfer operation.
 *        MCPM. 
 *         , 
 *          .
 *          
 *  u.       
 *        .
 *          
 *     ,     
 *     .   
 *            
 *   :
 *
 *	trans_completed
 *
 *     - ,   .
 */

typedef struct mcpm_iobatdesc {			/* I/O batch descroptor */
						/*   */
	mcpm_iopack_num_t
			packet_num;		/* number of packets in the */
						/* batch */
						/*     */
						/*    */
						/*    */
						/*   */
						/*   */
	mcpm_iopack_num_t
			batch_num;		/* number of batch buffer */
						/*    */
                                                /*   */
						/*     */
						/*     */
	mcpm_iopack_num_t
			real_packet_num;	/* number of real serviced */
						/* packets in the batch */
						/*   */
						/*    */
						/*  */
	mcpm_drv_err_t	common_error_code;      /* I/O transfer common error */
						/* code detected by driver */
						/*      */
						/*   */
						/*   */
						/* ( ) */
	u_short		trans_num;		/* unique number of transfer */
						/* associated with batch */
						/*    */
						/*  */
	u_short		trans_completed;	/* batch transfer with buf is */
						/* completed */
						/*  ,   */
						/*     */
} mcpm_iobatdesc_t;

/*
 *  MCPM physical packet of I/O operation (batch item)
 *        .
 *          ,   
 *    , ..     .
 *          31.
 */

typedef struct mcpm_iopack_desc {		/* I/O packet descriptor */
						/*   */
						/*    */
						/*    */
						/*    */
	mcpm_dev_num_t	device;			/* device number description */
						/*    */
	mcpm_iopack_size_t
			data_size;		/* byte size of transfered */
						/* packet data buffer */
						/*     */
						/*    */
						/*     */
						/*   */
	mcpm_drv_err_t	drv_error_code;		/* I/O transfer code of error */
						/* detected by driver */
						/*    */
						/*   */
						/* ( ) */
	mcpm_bcw_t	channel_check_word;	/* MCPM channel hardware  */
						/* built-in check word state */
						/*   */
						/*   */
						/* (   */
						/*   ) */

	mcpm_iopack_op_t	io_flags;	/* I/O operation flags */
						/* (MCPM_READ / MCPM_WRITE) */
						/*     */
						/*  */
	mcpm_iopack_clock_t	clock_num;	/* clock number (T350) of */
						/* MCPM packets */
						/*   350 */
						/*     */
						/*    */
} mcpm_iopack_desc_t;

/*
 *  MCPM data buffer of packet of I/O operation
 *      
 *            
 *    '   ,
 *        
 *       DMA.
 */

typedef union mcpm_iopack_buf {			/* I/O packet data buffer */
						/*    */
						/*   */
	mcpm_iopack_word_t			/* as array of MCPM channel */
						/* words */
						/*     */
						/*     MCPM */
						/* (2 , 16 ) */
		words[TO_MCPM_DMA_BURST_SIZE_ALIGN(MCPM_MAX_DATA_BUF_SIZE /
				sizeof(mcpm_iopack_word_t),
			sizeof(mcpm_iopack_word_t), 0, MCPM_DMA_BURST_SIZE)];
	u_long					/* as array of main memory */
						/* long words (int) */
						/*    */
						/*  (4  32 ) */
		longs[TO_MCPM_DMA_BURST_SIZE_ALIGN(MCPM_MAX_DATA_BUF_SIZE /
			sizeof(u_long), sizeof(u_long), 0,
			MCPM_DMA_BURST_SIZE)];
	u_char					/* as array of bytes */
						/*   */
		bytes[TO_MCPM_DMA_BURST_SIZE_ALIGN(MCPM_MAX_DATA_BUF_SIZE,
			sizeof(u_char), 0, MCPM_DMA_BURST_SIZE)];
} mcpm_iopack_buf_t;

/*
 *  Structure of batch of I/O operation packets
 *         MCPM
 *     ,       
 *           DMA.
 *          
 *   ,         
 *      
 *          
 *     .     
 *         , 
 *         , 
 *     .
 */

typedef struct mcpm_iobatch {		/* batch of I/O operation packets */
					/*     */
					/*  */
	mcpm_iobatdesc_t
		batch_desc;		/* descriptor of batch */
					/*   */

	mcpm_iopack_desc_t		/* descriptors of packets area */
					/*    */
					/*   */
		packets[TO_MCPM_DMA_BURST_SIZE_ALIGN(MCPM_MAX_PACKETS_NUM,
			sizeof(mcpm_iopack_desc_t), sizeof(mcpm_iobatdesc_t),
			MCPM_DMA_BURST_SIZE)];

	mcpm_iopack_buf_t		/* area of data buffers to write */
					/*     */
					/*       */
		data_bufs[MCPM_MAX_PACKETS_NUM];

	void				/* "opaque" user private area */
					/*   */
					/*      */
					/*    */
		*private_area[
			TO_MCPM_DMA_BURST_SIZE_ALIGN(MCPM_MAX_PACKETS_NUM,
				sizeof(void *), 0, MCPM_DMA_BURST_SIZE)];
} mcpm_iobatch_t;

/*
 *  MCPM I/O operation request specifications. The request consist of
 *  packets, Any packet points virtual address of arbitrary I/O data buffer.
 *  I/O operation results area for each packet pointed by own virtual address
 *        MCPM    
 *         
 *     .
 */

/*
 *  Batch of packets of I/O data transfer operation common results
 *        
 *  
 */

typedef	struct mcpm_iobatinfo			/* single I/O data transfer  */
						/* operation results info */
						/*    */
{
	u_short		trans_num;		/* unique number of transfer */
						/* associated with batch */
						/*    */
						/*  */
	mcpm_drv_err_t	common_error_code;      /* I/O transfer common error */
						/* code detected by driver */
						/*      */
						/*   */
						/*   */
						/* ( ) */
	u_char		board_error_code;	/* the MCPM board internal */
						/* register of error state */
						/*    */
						/*  () */
						/* (   */
						/*   ) */
	mcpm_iopack_num_t
			real_packet_num;	/* number of real serviced */
						/* packets in the batch */
						/*   */
						/*    */
						/*  */
	int		trans_errno;		/* value of errno for I/O */
						/* request, if zero then no */
						/* errors detected */
						/*    */
						/* ,  */
						/*  errno   */
						/*    */
						/*   */
						/*   - ,  */
						/*   n */
	hrtime_t	req_receive_time;	/* transfer request receiving */
						/* time (from uxer) */
						/*    */
						/*    */
	hrtime_t	intr_transfer_end;	/* interrupt on transfer end */
						/* on SPARC */
						/*   -  */
						/*     */
	hrtime_t	transfer_start;		/* transfer start time on */
						/* SPARC */
						/*    ( */
						/*   ) */
	hrtime_t	transfer_finish;	/* transfer finish time on */
						/* SPARC */
						/*     */
						/*  (  */
						/*   ) */
	hrtime_t	event_start_time;	/* some event start time */
						/*    */
						/*    */
						/* (   */
						/*    ) */
	hrtime_t	event_end_time;		/* some event end time */
						/*    */
						/*    */
						/* (   */
						/*    ) */
} mcpm_iobatinfo_t;

/*
 *  Specifications of batch of I/O data transfer operation packets.
 *          
 *        
 *         
 *  -
 */

typedef struct mcpm_iobatspec {			/* batch of I/O data transfer */
						/* specifications */
	mcpm_iobatdesc_t
			batch;			/* the batch descroptor */
						/*   */
	int		async_trans;		/* asynchronous transfer mode */
						/*   */
						/*   */
	int		timer_interval;		/* timer interval of waiting */
						/* for I/O batch end */
						/*    */
						/*    */
	mcpm_iobatinfo_t
			*common_results;	/* I/O batch common results */
						/*     */
						/*     */
						/*    */
						/*   */
						/*    NULL */
} mcpm_iobatspec_t;

typedef struct ctrl_com_result {    	/* results of control command */
					/*    */
				     /*      */
	u_char	mp_error_code;		/* I/O transfer code of error */
					/* detected by MP driver */
	u_char	channel_num;		/* channel number */
	mcpm_io_word_t  ctrl_command;	/* command word */
					/*   */
	u_char		lost_commands;	/*  ,  */
					/*   */
	u_char		data_presence;	/* 1 -    , */
					/* 0 -      */
					/*   */
	mcpm_io_word_t  data_word;	/* word of data */
					/*   */
	mcpm_io_word_t  answer_word;	/* answer word */
					/*  ,   */
					/*     */
					/*     */
	mcpm_io_word_t  vsk_word;	/* vsk */
					/*   */
} ctrl_com_result_t;

/*
 *  Optimum default value of batch transfer specifications
 */

#define	MCPM_BATCH_TRANS_TIMER_DEF	2000000	/* timer interval of waiting */
						/* for I/O transfer end (usec)*/


/*
 *  MCPM-device I/O operation map specifications
 *           
 *   (   )
 */

/*
 *  MCPM device I/O operation specifications.
 *      MCPM,     
 *   .    , 
 *     .     
 *     -   .     
 *    ,  ,      
 *         .
 *          
 *   :
 *                        ____________________________________
 *   mcpm_iosubd_desc ->  |             |
 *                        |      (         |
 *                        |        )        |
 *                        |                                  |
 *                        |----------------------------------|
 *   mcpm_data_buf    ->  |                |
 *                        |             |
 *                        |                      |
 *                        |                                  |
 *                        |                                  |
 *                        |                                  |
 *                        |                                  |
 *                        |                                  |
 *                        |                                  |
 *                        |                                  |
 *                        |                                  |
 *                        |__________________________________|
 *
 *            ,
 *     ,       
 *       - 8  (32 )  
 *            
 *    (DMA).     
 *            .
 *           
 *      (.    ).
 *              
 *     ,    
 *         'open_mcpm_drv.h'.
 *         ,    
 *  ,        
 *   (  MCPM   ,  ). 
 *          ,
 *   ,        
 *     .      
 *     .      
 *   -     .     
 *       .   
 *       
 *  'mcpm_iosubdbuf_t'  ,    
 *  'MCPM_MAX_DATA_BUF_SIZE'     
 *     .    
 *          
 *  ()  -     (. 
 *   ,          
 *  ).
 *          
 *      .    
 *         
 *        ,
 *        ,   ,
 *           (
 *     )      ,  
 *   .        
 *            , 
 *          
 *   .
 *
 *         :
 *            
 *          .
 *             
 *           ,
 *           
 *     .
 *              
 *        
 *       ,   
 *     ,     ,
 *           (
 *     )      ,  
 *   .        
 *            , 
 *         .
 *       ,   
 *   .     .   
 *        ,   
 *          
 *  .
 *           
 *         ,  
 *       .   
 *         
 *            
 *  .   ,       
 *            
 *      .
 *      :   ,
 *           .
 */

/*
 *  MCPM subdevice buffer of I/O operation descriptor (transfer map item)
 *      (  ), 
 *         MCPM. 
 *          ,   
 *    , ..   .
 *         
 *  ,        
 *   - 8  (32 )       
 *          (DMA).
 *         8   .
 *           
 *    .
 *           
 *     .
 *          
 *      ,    
 *        'open_mcpm_drv.h',   
 *        .
 *          
 *         :
 *	trans_completed
 *    - ,   .
 *    'trans_counter'      
 *              
 *       .   
 *             
 *     .
 */

typedef struct mcpm_iosubd_desc {		/* I/O transfer descriptor */
						/*   */
						/*   */
						/*  */
	mcpm_bcw_t	channel_check_word;	/* MCPM channel hardware  */
						/* built-in check word state */
						/*   */
						/*   */
						/* (   */
						/*   ) */
	u_char		board_error_code;	/* the MCPM board internal */
						/* register of error state */
						/*    */
						/*  () */
						/* (   */
						/*   ) */
	mcpm_drv_err_t	drv_error_code;		/* I/O transfer code of error */
						/* detected by driver */
						/*    */
						/*   */
						/* ( ) */
	u_short		trans_num;		/* unique number of transfer */
						/* associated with batch */
						/*    */
						/*    */
	char		trans_counter;		/* counter of transfers */
						/* with this buf of subdevice */
						/*     */
						/*   */
						/*   ,  */
						/*     */
						/*    */
						/*    */
						/*   */
						/*     */
	u_char		trans_completed;	/* subdevice transfer with */
						/* buf is completed */
						/*  ,   */
						/*     */
	mcpm_ccw_t	control_word;		/* the channel control word */
						/* received from channel */
						/*    */
						/*     */
						/*   */
	short		real_byte_size;		/* byte size of actually */
						/* transfered by subdevice */
						/*  :  */
						/* -   */
						/*   */
	mcpm_io_word_t	data_word;		/*  ,  */
						/*    */
	u_short		unused_word3;		/* unused word of structure */
						/*     */
						/*    */
						/*  - 8  */
	mcpm_io_op_t	io_flags;		/* I/O operation flags */
						/* (MCPM_IO_READ  */
						/* MCPM_IO_WRITE) */
						/*    */
                                                /*   */
						/*    */
						/*     */
	mcpm_iodev_num_t
			sub_addr;		/* subaddress of device */
						/*   */
						/*   */
						/*    */
						/*     */
	char		buf_num;		/* number of subdevice buffer */
						/*    */
						/*  */
                                                /*   */
						/*    */
						/*     */
	mcpm_io_size_t	data_size;		/* byte size of transfered */
						/* data by subdevice */
						/*     */
						/*    */
						/*     */
						/*   */
						/*   */
						/*  */
						/*    */
						/*    */
	void		*private_info;		/* "opaque" user private area */
						/*  */
						/*     */
						/*  */
	hrtime_t	drv_time;
/*	long		unused_word6;	*/	/* unused word of structure */
						/*     */
						/*    */
						/*  - 8  */
/*	long		unused_word7;	*/	/* unused word of structure */
						/*     */
						/*    */
						/*  - 8  */
} mcpm_iosubd_desc_t;

/*
 *  MCPM data buffer of subdevice I/O operation
 *        
 *            
 *    '   ,
 *        
 *       DMA.
 */

typedef union mcpm_data_buf {			/* I/O packet data buffer */
						/*    */
						/*  */
	mcpm_io_word_t				/* as array of MCPM channel */
						/* words */
						/*     */
						/*     MCPM */
						/* (2 , 16 ) */
		words[TO_MCPM_DMA_BURST_SIZE_ALIGN(MCPM_MAX_DATA_BUF_SIZE /
				sizeof(mcpm_io_word_t),
			sizeof(mcpm_io_word_t), 0, MCPM_DMA_BURST_SIZE)];
	u_long					/* as array of main memory */
						/* long words (int) */
						/*    */
						/*  (4  32 ) */
		longs[TO_MCPM_DMA_BURST_SIZE_ALIGN(MCPM_MAX_DATA_BUF_SIZE /
			sizeof(u_long), sizeof(u_long), 0,
			MCPM_DMA_BURST_SIZE)];
	u_char					/* as array of bytes */
						/*   */
		bytes[TO_MCPM_DMA_BURST_SIZE_ALIGN(MCPM_MAX_DATA_BUF_SIZE,
			sizeof(u_char), 0, MCPM_DMA_BURST_SIZE)];
} mcpm_data_buf_t;

/*
 *  Structure of subdevice I/O operation buffer
 *         MCPM
 *          
 *   ,        
 *       .
 *          
 *     .     
 *         , 
 *      .
 */

typedef struct mcpm_iosubdbuf {		/* subdevice buffer of I/O operation */
					/*     */
					/*   */
	mcpm_iosubd_desc_t
		buf_desc;		/* descriptor of buffer */
					/*     */

	mcpm_data_buf_t			/* data buffer to read or to write */
					/*      */
					/*     */
		data_buf;

} mcpm_iosubdbuf_t;

/*
 *  Subdevice buffer of I/O operations map
 *        MCPM - .
 *         -  
 *    .
 *        
 *        .
 */

typedef struct mcpm_iomap_subd {	/* subdevice buffer of I/O operation */
					/* map */
					/*     */
					/*  MCPM -  */
	mcpm_iosubdbuf_t	write;	/* buffer of transmitter */
					/*   */
	mcpm_iosubdbuf_t	read;	/* buffer of receiver */
					/*   */

} mcpm_iomap_subd_t;

/*
 *  MCPM device I/O operations map
 *      MCPM -    .
 *        
 *        .
 */

typedef mcpm_iomap_subd_t		mcpm_iomap_t;

/*
 *  MCPM device I/O operation request specifications. 
 *        MCPM    
 *         
 *        .
 */

/*
 *  Batch of packets of I/O data transfer operation common results
 *        
 *       .
 */

typedef	struct mcpm_iosubdinfo			/* subdevice of transfer map */
						/* I/O operation results info */
						/*   */
						/*   */
{
	u_short		trans_num;		/* unique number of transfer */
						/* associated with it */
						/*    */
						/*    */
	mcpm_drv_err_t	drv_error_code;         /* I/O transfer code of error */
						/* detected by driver */
						/*    */
						/*   */
						/* ( ) */
	mcpm_bcw_t	channel_check_word;	/* MCPM channel hardware  */
						/* built-in check word state */
						/*   */
						/*   */
						/* (   */
						/*   ) */
	u_char		board_error_code;	/* the MCPM board internal */
						/* register of error state */
						/*    */
						/*  () */
						/* (   */
						/*   ) */
	size_t		real_byte_size;		/* byte size of actually */
						/* transfered */
						/* set by driver and return */
						/* as I/O operation result */
						/*  :  */
						/* -   */
						/*   */
	int		trans_errno;		/* value of errno for I/O */
						/* request, if zero then no */
						/* errors detected */
						/*    */
						/* ,  */
						/*  errno   */
						/*    */
						/*   */
						/*   - ,  */
						/*   n */
	hrtime_t	req_receive_time;	/* transfer request receiving */
						/* time (from uxer) */
						/*    */
						/*    */
	hrtime_t	intr_transfer_end;	/* interrupt on transfer end */
						/* on SPARC */
						/*   -  */
						/*     */
	hrtime_t	transfer_start;		/* transfer start time on */
						/* SPARC */
						/*    ( */
						/*   ) */
	hrtime_t	transfer_finish;	/* transfer finish time on */
						/* SPARC */
						/*     */
						/*  (  */
						/*   ) */
	hrtime_t	event_start_time;	/* some event start time */
						/*    */
						/*    */
						/* (   */
						/*    ) */
	hrtime_t	event_end_time;		/* some event end time */
						/*    */
						/*    */
						/* (   */
						/*    ) */
} mcpm_iosubdinfo_t;

/*
 *  Specifications of I/O operation of subdevice of transfer map
 *          
 */

typedef struct mcpm_iosubdspec
{
	caddr_t		buf_base;		/* memory data buffer base */
						/* address */
						/*    */
						/*  */
	mcpm_io_size_t	buf_byte_size;		/* byte size of transfered */
						/* data array */
						/*     */
						/*  */
	mcpm_io_op_t	io_flags;		/* I/O operation flags */
						/* (MCPM_READ / MCPM_WRITE) */
						/*   , */
	mcpm_iodev_num_t
			sub_addr;		/* subaddress of device */
						/*   */
	mcpm_iosubdinfo_t
			*trans_res_info;	/* transfer results info */
						/*     */
						/*    */
						/*   */
						/*    NULL */
} mcpm_iosubdspec_t;


/*
 *  MCPM I/O operation in the test mode specifications
 *           
 *  (   ,    )
 */


/*
 *  Results of simple I/O transfer in the test mode
 *       
 *     
 */

typedef	struct mcpm_iotrinfo			/* single I/O data transfer  */
						/* operation results info */
						/*    */
						/*    */
{
	u_short		trans_num;		/* unique number of transfer */
						/* associated with it */
						/*    */
	mcpm_drv_err_t	drv_error_code;         /* I/O transfer code of error */
						/* detected by driver */
						/*    */
						/*   */
						/* ( ) */
	mcpm_bcw_t	channel_check_word;	/* MCPM channel hardware  */
						/* built-in check word state */
						/*   */
						/*   */
						/* (   */
						/*   ) */
	u_char		board_error_code;	/* the MCPM board internal */
						/* register of error state */
						/*    */
						/*  () */
						/* (   */
						/*   ) */
	size_t		real_byte_size;		/* byte size of actually */
						/* transfered */
						/* set by driver and return */
						/* as I/O operation result */
						/*  :  */
						/* -   */
						/*   */
						/*   */
						/*   */
						/*  ,   */
						/*  */
	int		trans_errno;		/* value of errno for I/O */
						/* request, if zero then no */
						/* errors detected */
						/*    */
						/* ,  */
						/*  errno   */
						/*    */
						/*   */
						/*   - ,  */
						/*   n */
	int		burst_byte_size;        /* used I/O transfer burst */
						/* bytes size */
						/*    */
						/*   */
						/* DMA  */
	hrtime_t	req_receive_time;	/* transfer request receiving */
						/* time (from uxer) */
						/*    */
						/*    */
	hrtime_t	intr_transfer_end;	/* interrupt on transfer end */
						/* on SPARC */
						/*   -  */
						/*     */
	hrtime_t	transfer_start;		/* transfer start time on */
						/* SPARC */
						/*    ( */
						/*   ) */
	hrtime_t	transfer_finish;	/* transfer finish time on */
						/* SPARC */
						/*     */
						/*  (  */
						/*   ) */
	hrtime_t	event_start_time;	/* some event start time */
						/*    */
						/*    */
						/* (   */
						/*    ) */
	hrtime_t	event_end_time;		/* some event end time */
						/*    */
						/*    */
						/* (   */
						/*    ) */
} mcpm_iotrinfo_t;

/*
 *  Specifications of single I/O data transfer operation in the test mode
 *     ()     
 */

typedef struct mcpm_iotrspec
{
	caddr_t		buf_base;		/* memory data buffer base */
						/* address */
						/*    */
						/*  */
	mcpm_io_size_t	buf_byte_size;		/* byte size of transfered */
						/* data array */
						/*     */
						/*  */
	mcpm_io_op_t	io_flags;		/* I/O operation flags */
						/* (MCPM_READ / MCPM_WRITE) */
						/*   , */
	int		async_trans;		/* asynchronous transfer mode */
						/*   */
						/*   */
	int		io_mode_flags;		/* I/O mode flags */
						/* (DMA_TRANSFER_IO_MODE ...) */
						/*   : */
						/* (DMA_TRANSFER_IO_MODE ...) */
	int		burst_sizes;		/* allowed burst sizes for */
						/* DMA transfer */
						/*    */
						/*   DMA- */
	int		timer_interval;		/* timer interval of waiting */
						/* for I/O transfer end */
						/*    */
						/*    */
	int		cntr_flag;		/* channel is inited as */
						/* controller (if flag == 0 */
						/* then as device) */
						/*  ,   */
						/*  , */
						/*  0,   */
	mcpm_iodev_num_t
			device_num;		/* device # description */
						/* (only as controller use */
						/* of channel is needed */
						/*   */
						/*    */
						/*    */
	mcpm_iodev_num_t
			subdevice_num;		/* subdevice # description */
						/* (only as controller use */
						/* of channel is needed */
						/*   */
						/*    */
						/*    */
	mcpm_iotrinfo_t	*trans_res_info;	/* transfer results info */
						/*     */
						/*    */
						/*   */
						/*    NULL */
} mcpm_iotrspec_t;

/*
 *  Optimum default value of transfer specifications
 *        
 */

#define	MCPM_TRANS_TIMER_INTERVAL_DEF	2000000	/* timer interval of waiting */
						/* for I/O transfer end (usec)*/
						/*    */
						/*    */

/*
 *  MCPM board channel I/O transfer state initialization
 *        
 */


/*
 *  MCPM board batch of I/O data transfer operation packets state
 *  initialization
 *        MCPM
 *         
 *  ,         
 *        .
 *          .
 */

typedef struct mcpm_init_batch {		/* MCPM init transfer state */
						/* specifications */
	mcpm_iopack_num_t
			max_packets_num;	/* max number of packets in */
						/* I/O operations batch */
						/*    */
						/*      */
						/*  (  */
						/*    DMA) */
	mcpm_iopack_size_t
			max_data_buf_size;	/* max size of I/O data */
						/* buffer */
						/*   */
						/*     */
						/*  (  */
						/*    DMA) */
	int		buf_num;		/* # of buffers for I/O data */
						/* transfer */
						/*    */
						/*     */
	u_long		timer_interval;		/* hangup of channel I/O */
						/* transfer timer interval */
						/* (usec) */
						/*    */
						/*   */
						/*   */
						/*     */
						/* ( ) */
	int		poll_mode_flag;		/* poll mode: transfer finish */
						/* must be polled */
						/*    */
						/*   */
						/* :    */
						/*   poll()  */
						/*   */
						/*   */
	int		async_start_mode;	/* asynchronous start of */
						/* batch mode */
						/*    */
						/*    */
						/*   0 -   */
						/*    */
						/*    */
						/*    */
						/*   1 -   */
						/*    */
						/*  */
	mcpm_adp_mode_t	cntr_mode_state;	/* channel adapter hardware */
						/* control-state mode bits */
						/*   */
						/*  */
	size_t		*real_buf_size_p;	/* real size of transfer buf */
						/*    */
						/*    */
						/*    c */
						/*     */
						/*   */
						/*   */
	int		*error_code_p;		/* code of error detected by */
						/* driver (SPARC or MP) */
						/* during  initialization */
						/*    */
						/*    , */
						/*    */
						/*    */
						/*  */
} mcpm_init_batch_t;

/*
 *  Default value of I/O transfer state specifications
 *         
 */

#define	MCPM_BATCH_BUF_NUM_DEF		4	/* default value of MCPM */
						/* number of transfer bufs */
						/*    */
#define	MCPM_MIN_BATCH_BUF_NUM		4	/* value of MCPM min */
						/* number of transfer bufs */
						/*   */
						/*    */
#define	MCPM_MAX_BATCH_BUF_NUM		4	/* value of MCPM max */
						/* number of transfer bufs */
						/*   */
						/*    */
#define	MCPM_MAX_TRANS_BATCH_QUEUE_SIZE	3	/* max number of transfer */
						/* batches in the queue */
						/*    */
						/*  , */
						/*   */
						/* ,    */
						/*   */
						/* 2   */
						/* 1   */
						/* 1 , */
						/* 1   */
						/* 1    */
#define	MCPM_HUNGUP_TIMER_INTERVAL_DEF	800	/* default value of MCPM */
						/* hangup of I/O transfer */
						/* timer interval (usec) */
						/*    */
						/*   */
						/*   */
						/*     */
						/* ( ) */


/*
 *  MCPM device of I/O data transfer subdevice map state initialization
 *       MCPM   
 *          ,
 *       ,  
 *      .
 *          .
 */

typedef struct mcpm_init_iomap {		/* MCPM-device init transfer */
						/* state specifications */
						/*   */
						/*  MCPM   */
						/*  */
	mcpm_iodev_num_t
			device_num;		/* the device address */
						/*  ,  */
						/*   */
						/*  */
	mcpm_iodev_num_t
			min_subdevice_num;	/* min # of subdevice for */
						/* the device */
						/*   */
						/* -,  */
						/*    */
						/* (  */
						/*   ,  */
						/*    */
						/*  -) */
	mcpm_iodev_num_t
			max_subdevice_num;	/* max # of subdevice for */
						/* the device */
						/*   */
						/* -,  */
						/*    */
						/* (  */
						/*   ,  */
						/*    */
						/*  -) */
	mcpm_io_size_t	max_data_buf_size;	/* max size of I/O data */
						/* buffer */
						/*   */
						/*     */
						/*  ( */
						/*     */
						/* DMA) */
	int		buf_num;		/* # of buffers for I/O data */
						/* transfer */
						/*    */
						/*    */
	u_long		timer_interval;		/* hangup of channel I/O */
						/* transfer timer interval */
						/* (usec) */
						/*    */
						/*   */
						/*   */
						/*     */
						/* ( ) */
	int		poll_mode_flag;		/* poll mode: transfer finish */
						/* must be polled */
						/*    */
						/*   */
						/* :    */
						/*   poll()  */
						/*   */
						/*      */
						/*  */
	mcpm_adp_mode_t	cntr_mode_state;	/* channel adapter hardware */
						/* control-state mode bits */
						/*   */
						/*  */
	size_t		*real_buf_size_p;	/* real size of transfer buf */
						/*    */
						/*    */
						/*    */
						/*  c   */
						/*  -  */
						/*   */
						/*   */
						/*   */
	int		*error_code_p;		/* code of error detected by */
						/* driver (SPARC or MP) */
						/* during  initialization */
						/*    */
						/*    , */
						/*    */
						/*    */
						/*  */
} mcpm_init_iomap_t;

/*
 *  Default value of MCPM device I/O transfer map mode state specifications
 *         
 *  .
 */

#define	MCPM_E90_DEVICE_NUM_DEF		0x00	/* default value of MCPM */
						/* the device address */
						/*  ,  */
						/*    */
						/*  */
#define	MCPM_MIN_SUBDEVICE_NUM_DEF	MCPM_MIN_SUBDEVICE_NUM
						/* min # of subdevice for */
						/* the device */
						/*   */
						/* -,  */
						/*    */
#define	MCPM_MAX_SUBDEVICE_NUM_DEF	MCPM_MAX_SUBDEVICE_NUM
						/* max # of subdevice for */
						/* the device */
						/*   */
						/* -,  */
						/*    */
#define	MCPM_MAX_DATA_BUF_SIZE_DEF	64	/* default value of MCPM max */
						/* size of I/O transfer */
						/*    */
#define	MCPM_SUBDEV_BUF_NUM_DEF		2	/* default value of MCPM */
						/* number of transfer bufs */
						/*    */
						/*   - */
#define	MCPM_MIN_SUBDEV_BUF_NUM		1	/* value of MCPM min */
						/* number of transfer bufs */
						/*   */
						/*    */
						/*   - */
#define	MCPM_MAX_SUBDEV_BUF_NUM		8	/* value of MCPM max */
						/* number of transfer bufs */
						/*   */
						/*    */
						/*   - */
						/*     */
						/*    -  */
						/* 1 ()  */
#define	MCPM_HUNGUP_TIMER_INTERVAL_DEF	800	/* default value of MCPM */
						/* hangup of I/O transfer */
						/* timer interval (usec) */
						/*    */
						/*   */
						/*   */
						/*     */
						/* ( ) */
#define	MCPM_CNTR_MODE_STATE_BITS_DEF	0x00	/* default value of MCPM */
						/* channel adapter */
						/* control-state mode bits */
						/*   */
						/*  */

/*
 *  MCPM board I/O transfer state halt
 *         
 */

typedef struct mcpm_halt_trans {		/* halt transfer state and */
						/* close channel request */
						/*    */
						/*    */
						/*    */
	int		waiting_time;		/* timer interval of waiting */
						/* for last transfer will be */
						/* finished and channel */
						/* closed (usec) */
						/*    */
						/*    */
						/*  ,  */
						/*    */
						/*   */
						/*  0,    */
						/*     */
						/*   */
						/*    - */
						/* ( close() ) */
						/*  < 0,   */
						/*     */
						/*    */
						/*    */
						/*    */
						/*   */
						/*  > 0,     */
						/* ,  */
						/*     */
						/*   */

} mcpm_halt_trans_t;

/*
 *  The driver private buffers management (support and strategy of buffer
 *  transfer from/to main memory and to/from user  requests.
 *        
 *     
 *  (      -90 )
 */

typedef me90_buf_man_t			mcpm_buf_man_t;

/*
 *  Optimum default value of driver main memory buffers management args
 *          
 */

#define	MIN_MCPM_FREE_BUF_NUM_DEF	1	/* 1 for next transfer */
						/* 1   */
						/*   */
#define	MAX_MCPM_BUF_NUM_DEF		1 	/* only 1 transfer available */
						/* at any time */
						/*  1    */
						/*    */
#define	MIN_MCPM_TOTAL_BUF_NUM_DEF	1	/* in progress + next + free */
						/* 1   + */
						/* 0   + */
						/* 0   */

/*
 *  MCPM channel I/O single transfer mode state initialization
 *         
 *  ()  (    ,    ).
 *          MCPM
 */

typedef struct mcpm_init_trans {		/* MCPM init transfer mode */
						/* specifications */
						/*    */
						/*   */
						/*   */
	int		cntr_flag;		/* channel is inited as */
						/* controller (if flag == 0 */
						/* then as device) */
						/*  ,   */
						/*   */
						/*  */
	mcpm_iodev_num_t
			device_num;		/* the device address if */
						/* channel must be device */
						/* rathe controller */
						/*  ,  */
						/*    */
						/*  */
	size_t		max_trans_size;		/* max size of I/O transfer */
						/*    */
						/*  */
						/*  <= 0,   */
						/*     */
						/*    */
	u_long		timer_interval;		/* hangup of I/O transfer */
						/* timer interval (usec) */
						/*    */
						/*    */
						/*    */
	mcpm_adp_mode_t	cntr_mode_state;	/* channel adapter hardware */
						/* control-state mode bits */
						/*   */
						/*  */
	int		waiting_time;		/* timer interval of waiting */
						/* for all transfers will be */
						/* finished and channel can */
						/* be closed (usec) */
						/* if 0 then all */
						/* not terminated transfers */
						/* deleted immediately */
						/* if < 0 then "infinite" */
						/* waiting while all */
						/* transfers will be done */
						/* if > 0 then timed waiting */
						/* for transfers end and */
						/* delete residual transfers */
						/*    */
						/*  ,  */
						/*     , */
						/*     */
						/*   */
						/*  0,     */
						/*    */
						/*   */
						/*  < 0,   */
						/*   */
						/*  > 0,     */
						/* ,  */
						/*    */
						/*   */
	mcpm_buf_man_t	*trans_buf_management;	/* management of driver main */
						/* memory buffers for data */
						/* transfer from/to user */
						/* request */
						/*    */
						/*     */
						/*    */
						/*    */
						/*    */
						/*  NULL,   */
						/*     */
						/*   , */
						/*   */
	int		*error_code_p;		/* code of error detected by */
						/* driver (SPARC or MP) */
						/*    */
						/*    */
						/*   */
						/*  */
} mcpm_init_trans_t;

/*
 *  Default value of MCPM single transfer mode state specifications
 *         
 *   .
 */

#define	MCPM_E90_DEVICE_NUM_DEF		0x00	/* default value of MCPM */
						/* the device address */
						/*  ,  */
						/*    */
						/*  */
#define	MCPM_MAX_DATA_BUF_SIZE_DEF	64	/* default value of MCPM max */
						/* size of I/O transfer */
						/*    */
#define	MCPM_CNTR_MODE_STATE_BITS_DEF	0x00	/* default value of MCPM */
						/* channel adapter */
						/* control-state mode bits */
						/*   */
						/*  */
#define	MCPM_HALT_TRANS_WAIT_TIME_DEF	-1	/* default value of waiting */
						/* time for all transfers end */
						/* (usec) */
						/*    */
						/*  ,  */
						/*     , */
						/*     */
						/*   */
						/*  */

/*
 *  Driver state and modes some info structure (like all other module of E-90)
 *         
 *         
 *  ioctl() 
 *  (      -90 )
 */

typedef me90_drv_info_t			mcpm_drv_info_t;

/*
 *  MCPM device (instance & channel) info
 *         MCPM
 *      
 *         
 *  ioctl() .
 */

typedef	struct mcpm_dev_info {
	int		instance;	/* instance of MCPM module */
	int		channel;	/* instance of MCPM module */
	int		cntr_flag;	/* channel open as controller */
} mcpm_dev_info_t;

/*
 *  Module External Interrupts Generation Set/Reset in internal test mode
 */

typedef struct mcpm_intr_set
{
	int		timer_interval;		/* timer interval of */
						/* interrupts generation */
} mcpm_intr_set_t;

#ifdef	__cplusplus
}
#endif

#endif	/* __MCPM_IO_H__ */

