/*
 *
 * Ported in Linux by Alexey V. Sitnikov, alexmipt@mcst.ru, MCST, 2004
 *
 */

/*   mmr_io.h:
				 - 14.07.04; home - 19.04.04.
*/
/* 12.07.04 -     */

/*   ,   
     */

#ifndef _LINUX_MMR_IO_H__
#define _LINUX_MMR_IO_H__

#ifdef	__cplusplus
extern "C" {
#endif

#include <linux/mcst/linux_me90_io.h>

#define	VERSION_LIB_PROCEDURE		0x15040401
/*    */

#ifndef MMR_OLD_VERSION
/*   */
#define	VERSION_MODULE_MMR	0x17040504
/*   */
#define	work_var_module			16
#endif /* MMR_OLD_VERSION */

/*       MMR  
*      ioctl()
*/

#ifdef MMR_OLD_VERSION
#define	MMRIO_READ_DEVICE_REG				(ME90_IO | 1)
#define	MMRIO_WRITE_DEVICE_REG				(ME90_IO | 2)
#define	MMRIO_INIT_BUFERS_EXCHANGE			(ME90_IO | 3)
#define	MMRIO_INIT_DEVICE				(ME90_IO | 4)
#define	MMRIO_HALT_TRANSFER_MODES			(ME90_IO | 5)
#define	MMRIO_GET_DEVICE_INFO				(ME90_IO | 6)
#define	MMRIO_INTR_TIME_WAIT				(ME90_IO | 7)

#define MMR_CNTR_ST_REG_SET_OFFSET		0x10000 /*    */
#define MMR_CNTR_ST_REG_SET_LEN        		0x100	/*    */
#define	MMR_BMEM_REG_SET_OFFSET			0x40000 /*    */
#define	MMR_BMEM_REG_SET_LEN			0x20000 /*     */

#define	BCW_HARDWARE_MMR_ERROR		12
#else
#define MMR_IO			('M' << 8)
#define	MMRIO_GET_DRIVER_INFO				(MMR_IO | 1)
#define	MMRIO_READ_DEVICE_REG				(MMR_IO | 2)
#define	MMRIO_WRITE_DEVICE_REG				(MMR_IO | 3)
#define	MMRIO_INIT_BUFERS_EXCHANGE			(MMR_IO | 4)
#define	MMRIO_INIT_DEVICE				(MMR_IO | 5)
#define	MMRIO_HALT_TRANSFER_MODES			(MMR_IO | 6)
#define	MMRIO_GET_DEVICE_INFO				(MMR_IO | 7)
#define	MMRIO_INTR_TIME_WAIT				(MMR_IO | 8)
#define	MMRIO_NUM_INTR_ROSH				(MMR_IO | 9)

#define MMR_ADDR_CNTRL_INFRM_BUFFERS_DATAS	0x1000 	/*    */
													/*   */
													/*   */
#define	MMR_BMEM_REG_SET_OFFSET		0x40000 /*    */
#define	MMR_BMEM_REG_SET_LEN		0x20000 /*    */

#define	MMR_TIMER_INTE			1000000	/*    */
						/*   () */
						/* ( ) */
#endif /* MMR_OLD_VERSION */

//#define	MMR_HUNGUP_TIMER_INTERVAL	720000
#define	MMR_HUNGUP_TIMER_INTERVAL	360000
									/*    */
									/*    */
									/* ( ) */

#define	MMR_IO_WRITE		0x01		/*  () */
#define	MMR_IO_READ		0x02		/*  () */

#ifndef MMR_OLD_VERSION
#define	BLOCK_ERROR_DEV  	1   /*    */
#define	NO_BLOCK_ERROR_DEV  	0   /*     */
#define	BLOCK_ERROR_ROSH  	1   /*    */
				    /*    */
#define	NO_BLOCK_ERROR_ROSH 	0   /*     */
				    /*    */
#define	GISTOGR			8   /*     */
#define	GISTOGR_COMM		16  /*     */
#endif /* MMR_OLD_VERSION */

/*    */
#define	MODE_CONTROLLER		   1
#define	MODE_TERMINAL		   2
#define	MODE_MONITOR		   3

#ifndef MMR_OLD_VERSION
/*     */
#define	CHECKOUT		   1 /*  ,    */
#define	AUDIT_TE		   2 /*     */
#define	ENABLE		   	   3 /*  ,   */
#define	AUDIT_MNTR		   4 /*        */
#define	AUDIT_ONE_module   	   5 /*    */
#endif /* MMR_OLD_VERSION */

#ifndef MMR_OLD_VERSION
/*     */
/*     */
#define	  fulfilment_command_cntrl 	1
/*     */
#define	  realiz_generic_comm_cntrl	2
/*       
     */
#define	 exchange_between_cntrl_term	3
/*      
     */
#define	 transfer_from_cntrl_terminals	4
/*       */
#define	 exchange_between_terminals		5
/*        
      */
#define	 transfer_from_term_terminals	6
#endif /* MMR_OLD_VERSION */

#ifdef MMR_OLD_VERSION
#define	EXPRESS_MODE		   4
#endif /* MMR_OLD_VERSION */

#define	MMR_MAX_NUM_TERMINAL		31  /* -   */
#define	MMR_SUBADRR_NUM_TERMINAL	30  /* -   */
#define	MMR_BUF_USER_NUM		33  /* -    */
#define	MMR_BUF_ADAPTER_NUM		32  /* -    */

#define	MMR_DMA_BURST_SIZE		8*4 /*    - char */

#ifdef MMR_OLD_VERSION
#define	MMR_MAX_WORD_DATA_BUF_RECIV	16  /*    - longs */
#define	MMR_MAX_NUM_BUF_COMM		16  /*     - longs */
#define	MMR_MAX_NUM_SUBARRAY		1   /* -    */
#define	MMR_SUBARRAY			32  /*     - words */
#define	ADDR_STATIST_CTRL		16  /*   - - words */										 
#define	MMR_MAX_WORD_DATA_BUF_TRANS	MMR_MAX_WORD_DATA_BUF_RECIV
									/*     */
									/*    */
#define	MMR_MAX_DATA_BUF_SIZE		MMR_MAX_WORD_DATA_BUF_RECIV*4
									/*     */
									/*   */
#else
#define	MMR_MAX_LONGS_DATA_BUF_RECIV  16  /*    - long */
#define	MMR_MAX_WORDS_DATA_BUF_RECIV  32  /*    - short */
#define	MMR_MAX_NUM_BUF_COMM	      16  /*     - long */
#define	ADDR_STATIST_CTRL	      16  /*   - - word */
#define	MMR_MAX_LONGS_DATA_BUF_TRANS	MMR_MAX_LONGS_DATA_BUF_RECIV
									/*     */
									/*    */
#define	MMR_MAX_DATA_BUF_SIZE		MMR_MAX_LONGS_DATA_BUF_RECIV*4
									/*     */
									/*   */
#endif /* MMR_OLD_VERSION */

#ifdef MMR_OLD_VERSION
#define	USK_TRANS_buf		0x36000401	/*      */
#define	USK_RECIV_buf		0x14000001	/*      */
#define	USK_CTRL_buf_comm	0x34200001	/*     */
#define	USK_TERM_buf_comm	0x00200001	/*     */
#define	SKB_buf_comm_CNTR	0x00010001	/*     */
#else
#define	USK_TRANS_buf		0x36000401	/*      */
#define	USK_RECIV_buf		0x14000001	/*      */
#define	USK_CTRL_buf_comm	0x34200001	/*     */
#define	USK_TERM_buf_comm	0x00200001	/*     */
#define	SKB_buf_comm_CNTR	0x01000202	/*     */
#define	SKB_buf_comm_MNTR	0x01001010	/*     */
#define	SKB_buf_date		0x01000202	/*    */
#endif /* MMR_OLD_VERSION */

#ifdef MMR_OLD_VERSION
#define MMR_ADDR_CNTRL_INFRM_BUFFERS_DATAS		0x1000	/*    */
								/*   */
								/*   */
#endif /* MMR_OLD_VERSION */

/*       */
#ifdef MMR_OLD_VERSION
/*   */
#define ERRPARAM  			1
/*    */
#define ERRMNTRSYS  		2
/*    */
#define SPECCONDTERM  		3
/*      */
#define RECWORDNOTADDTERM  	4
/*     ioctl */
#define ERROR_ACCESS_IOCTL 	5
/*    ioctl() */
#define ERROR_IOCTL         7
/*     */
#define ERROR_COMPARED      8
/*       */
#define NOT_UPKEEP      	9
/*    !=    */
#define DIFF_NUM_SUBARRAYS 	10
#else
/*   */
#define ERRPARAM  			1
/*    */
#define ERRMNTRSYS  		2
/*    */
#define SPECCONDTERM  		3
/*      */
#define RECWORDNOTADDTERM  	4
/*     ioctl */
#define ERROR_ACCESS_IOCTL 	5
/*         */
#define NOT_INTR_NO_STOP    6
/* A    */
#define NO_STOP_ADAPTER    7
/*    ioctl() */
#define ERROR_IOCTL         8
/*    */
#define NOT_INTR         	9
/*   */
#define ERROR_ROCH          10
/*     */
#define ERROR_COMPARED      11
/*       */
#define NOT_UPKEEP      	12
/*    !=    */
#define DIFF_NUM_SUBARRAYS 	13
/*        */
#define ERRORVERDRVVK		164
#endif /* MMR_OLD_VERSION */

/*    */
#define UNARY_COMM_WORD      0
#define DOUBLE_COMM_WORD     1

/*	        
	       DMA.
	nelem -     
	elsize -    
	off -         
	bsize -      DMA
	 -       
	 MMR_DMA_BURST_SIZE */

#define	TU_MMR_DMA_BURST_SIZE_ALIGN(nelem, elsize, off, bsize) ((((((nelem) * \
		(elsize) + (off) + ((bsize)-1)) / (bsize)) * (bsize)) \
		- (off)) / (elsize))

/*      .  
	 .         -
	  .       
	,  ,      
	       .
	       , 
	 :
						  ____________________________________
	 mmr_iosubd_desc -> |             |
						|      (         |
						|        )        |
						|----------------------------------|
	 mmr_data_buf    -> |      ,           |
						|             |
						|__________________________________|

	          ,
	   ,     
	    - 8  (32 ),  
	          
	  (DMA).  ,
	      ,    .
	            
	   ,    
	       'open_mmr_drv.h'.
	       ,    
	,        
	 (  MMR,  ). 
	       ,
	  ,        
	   .      
	.      
	 -     .   
	     
	'mmr_iosubdbuf_t'  ,    
	MMR_MAX_DATA_BUF_SIZE   ,  
	   .    
	     ).
*/

/*     (  ), 
	      MMR    
	  .
		       
	,        
	 - 8  (32 ),       
	        (DMA).
	       8   .
	         
	  .
 */

#define MMR_TBLPPP	 0x00 /*      RERR[0] != 0 */
#define MMR_TPPP     0x04 /*     () */
#define MMR_TPCHSH   0x08 /*      */
#define MMR_TBZ      0x0C /*      */
#define MMR_TZCH     0x14 /*    SBus  */
#define MMR_RERR     0x10 /*   */
#define MMR_RNKSH    0x18 /*      */
#define MMR_TZM      0x20 /*    */
#define MMR_REG_CTRL 0x24 /*   */

#ifdef MMR_OLD_VERSION
#define base_reg   		0x300001 /*    */
#else
#define base_reg   		0x300101 /*    v 4 */
#define base_reg_v5   		0x300141 /*    v 5 */
#endif /* MMR_OLD_VERSION */
#define err_answer_word		0x0405  /*    */
#define err_word_mntr		0x4bdf  /*    */

/*   */
#ifdef MY_DRIVER_BIG_ENDIAN
typedef union mmr_reg_general
{
	u_int          rdwr_reg_general;
	struct
		{
			u_int  bit3129 : 3; /*    */
			u_int  bit2824 : 5; /*   */
			u_int  bit23	: 1; /*       */
			u_int  bit22 	: 1; /*   */
			u_int  bit21	: 1; /*  1-   */
			u_int  bit20 	: 1; /*  0-   */
			u_int  bit19 	: 1; /*    */
			u_int  bit18 	: 1; /*     */
			u_int  bit17 	: 1; /*   */
			u_int  bit16 	: 1; /*    */
			u_int  bit15 	: 1; /*   () */
			u_int  bit14 	: 1; /*   (   */
			u_int  bit13 	: 1; /*   () */
			u_int  bit1206 : 7; /*  - RNKSH */
			u_int  bit0503 : 3; /*  - RERR */
			u_int  bit02   : 1; /*  - TPCHSH */
			u_int  bit01   : 1; /*  - TPPP */
			u_int  bit00   : 1; /*  - TBLPPP */
		} as_bits_0;
} mmr_reg_general_t;
#else
typedef union mmr_reg_general
{
	u_int          rdwr_reg_general;
	struct
		{
			u_int  bit00   : 1; /*  - TBLPPP */
			u_int  bit01   : 1; /*  - TPPP */
			u_int  bit02   : 1; /*  - TPCHSH */
			u_int  bit0503 : 3; /*  - RERR */
			u_int  bit1206 : 7; /*  - RNKSH */
			u_int  bit13   : 1; /*   () */
			u_int  bit14   : 1; /*   (   */	
			u_int  bit15   : 1; /*   () */
			u_int  bit16   : 1; /*    */
			u_int  bit17   : 1; /*   */
			u_int  bit18   : 1; /*     */
			u_int  bit19   : 1; /*    */
			u_int  bit20   : 1; /*  0-   */
			u_int  bit21   : 1; /*  1-   */
			u_int  bit22   : 1; /*   */
			u_int  bit23   : 1; /*       */
			u_int  bit2824 : 5; /*   */
			u_int  bit3129 : 3; /*    */
		} as_bits_0;
} mmr_reg_general_t;
#endif /* MY_DRIVER_BIG_ENDIAN */

/*     
#define num_subarray_buf	as_bits_0.bit3129 */
/*   */
#define address_terminal 	as_bits_0.bit2824
/*       */
#define blokade_read_command as_bits_0.bit23
/*   */
#define busy_terminal	   	as_bits_0.bit22
/*  1-   */
#define blokade_channel1   	as_bits_0.bit21
/*  0-   */
#define blokade_channel0   	as_bits_0.bit20
/*    */
#define service_terminal 	as_bits_0.bit19
/*     */
#define accept_control 		as_bits_0.bit18
/*   */
#define blokade_error  		as_bits_0.bit17
/*    */
#define broren_parity  		as_bits_0.bit16
/*   (  ) */
#define run_monitor   		as_bits_0.bit15
/*   (   */
#define run_terminal 		as_bits_0.bit14
/*   (    ) */
#define run_controller		as_bits_0.bit13
#define	reg_RNKSH			as_bits_0.bit1206 	/*  - RNKSH */
#define	reg_RERR			as_bits_0.bit0503 	/*  - RERR */
#define	trg_TPCHSH			as_bits_0.bit02 	/*  - TPCHSH */
#define	trg_TPPP			as_bits_0.bit01 	/*  - TPPP */
#define	trg_TBLPPP			as_bits_0.bit00 	/*  - TBLPPP */

/*    */
#ifdef MY_DRIVER_BIG_ENDIAN
typedef union mmr_reg_cntrl
{
	u_int          wr_mmr_reg_cntrl;
	struct
		{
			u_int  bit3119 : 13; /*   */
			u_int  bit1816 : 3;  /*    */
			u_int  bit1511 : 5;  /*   */
			u_int  bit10   : 1;  /*       */
			u_int  bit09   : 1;  /*   */
			u_int  bit08   : 1;  /*  1-   */
			u_int  bit07   : 1;  /*  0-   */
			u_int  bit06   : 1;  /*    */
			u_int  bit05   : 1;  /*     */
			u_int  bit04   : 1;  /*   */
			u_int  bit03   : 1;  /*    */
			u_int  bit02   : 1;  /*   (  ) */
			u_int  bit01   : 1;  /*   (   */
			u_int  bit00   : 1;  /*   (    ) */
		} as_bits_1;
} mmr_reg_cntrl_t;
#else
typedef union mmr_reg_cntrl
{
	u_int          wr_mmr_reg_cntrl;
	struct
		{
			u_int  bit00   : 1;  /*   (    ) */
			u_int  bit01   : 1;  /*   (   */
			u_int  bit02   : 1;  /*   (  ) */
			u_int  bit03   : 1;  /*    */
			u_int  bit04   : 1;  /*   */
			u_int  bit05   : 1;  /*     */
			u_int  bit06   : 1;  /*    */
			u_int  bit07   : 1;  /*  0-   */
			u_int  bit08   : 1;  /*  1-   */
			u_int  bit09   : 1;  /*   */
			u_int  bit10   : 1;  /*       */
			u_int  bit1511 : 5;  /*   */
			u_int  bit1816 : 3;  /*    */
			u_int  bit3119 : 13; /*   */
		} as_bits_1;
} mmr_reg_cntrl_t;
#endif /* MY_DRIVER_BIG_ENDIAN */

/*    */
#define type_comm_word   	as_bits_1.bit1816 
/*   */
#define address_term      	as_bits_1.bit1511
/*       */
#define blokade_read_comm   as_bits_1.bit10
/*   */
#define busy_term		   	as_bits_1.bit09
/*  1-   */
#define blokade_ch1   		as_bits_1.bit08
/*  0-   */
#define blokade_ch0   		as_bits_1.bit07
/*    */
#define service_term   		as_bits_1.bit06
/*     */
#define accept_cntrl   		as_bits_1.bit05
/*   */
#define blokade_err		   	as_bits_1.bit04
/*    */
#define broren_part		   	as_bits_1.bit03
/*   (  ) */
#define run_mntr   			as_bits_1.bit02
/*   (   */
#define run_term   			as_bits_1.bit01
/*   (    ) */
#define run_ctrl   			as_bits_1.bit00

/*        */

#ifdef MY_DRIVER_BIG_ENDIAN
typedef union mmr_reg_comm
{
	u_short		  wr_mmr_reg_comm;
	struct
		{
			u_short  bit1511  : 5;  /*   */
			u_short  bit10 	  : 1;  /*   */
			u_short  bit0905  : 5;  /* /  */
			u_short  bit0400  : 5;  /*  /  */
		} as_bits_2;
} mmr_reg_comm_t;
#else
typedef union mmr_reg_comm
{
	u_short		  wr_mmr_reg_comm;
	struct
		{
			u_short  bit0400  : 5;  /*  /  */
			u_short  bit0905  : 5;  /* /  */
			u_short  bit10 	  : 1;  /*   */
			u_short  bit1511  : 5;  /*   */
		} as_bits_2;
} mmr_reg_comm_t;
#endif /* MY_DRIVER_BIG_ENDIAN */

/*   */
#define addr_term      		as_bits_2.bit1511
/*   */
#define set_trans   		as_bits_2.bit10
/* /  */
#define subaddr_cntrl   	as_bits_2.bit0905
/*  /  */
#define numword_codecomm  	as_bits_2.bit0400

/*    */
#ifdef MY_DRIVER_BIG_ENDIAN
typedef union mmr_word_date
{
	u_short		  wr_mmr_word_date;
	struct
		{
			u_short  bit1511  : 5;  /*   */
			u_short  bit10 	  : 1;  /*   */
			u_short  bit0905  : 5;  /*  */
			u_short  bit0400  : 5;  /*    */
		} as_bits_5;
} mmr_word_date_t;
#else
typedef union mmr_word_date
{
	u_short		  wr_mmr_word_date;
	struct
		{
			u_short  bit0400  : 5;  /*    */
			u_short  bit0905  : 5;  /*  */
			u_short  bit10 	  : 1;  /*   */
			u_short  bit1511  : 5;  /*   */
		} as_bits_5;
} mmr_word_date_t;
#endif /* MY_DRIVER_BIG_ENDIAN */

/*   */
#define addr_trmnl      	as_bits_5.bit1511 
/*  */
#define subaddr				as_bits_5.bit0905
/*    */
#define serial_num_word 	as_bits_5.bit0400 

/*    */
#ifdef MY_DRIVER_BIG_ENDIAN
typedef union mmr_answer_word
{
	u_short		  wr_mmr_answer_word;
	struct
		{
			u_short  bit1511  : 5;  /*   */
			u_short  bit10 	  : 1;  /*    */
			u_short  bit09    : 1;  /*   */
			u_short  bit08    : 1;  /*    */
			u_short  bit0705  : 3;  /*  */
			u_short  bit04    : 1;  /*    */
			u_short  bit03 	  : 1;  /*   */
			u_short  bit02    : 1;  /*   */
			u_short  bit01    : 1;  /*    */
			u_short  bit00    : 1;  /*   */
		} as_bits_3;
} mmr_answer_word_t;
#else
typedef union mmr_answer_word
{
	u_short		  wr_mmr_answer_word;
	struct
		{
			u_short  bit00    : 1;  /*   */
			u_short  bit01    : 1;  /*    */
			u_short  bit02    : 1;  /*   */
			u_short  bit03 	  : 1;  /*   */
			u_short  bit04    : 1;  /*    */
			u_short  bit0705  : 3;  /*  */
			u_short  bit08    : 1;  /*    */	
			u_short  bit09    : 1;  /*   */
			u_short  bit10 	  : 1;  /*    */
			u_short  bit1511  : 5;  /*   */
		} as_bits_3;
} mmr_answer_word_t;
#endif /* MY_DRIVER_BIG_ENDIAN */

/*   */
#define addr_terminal		as_bits_3.bit1511
/*    */
#define err_msg				as_bits_3.bit10
/*   */
#define trans_AW			as_bits_3.bit09
/*    */
#define demand_upkeep		as_bits_3.bit08
/*    */
#define generic_comm_accept	as_bits_3.bit04
/*   */
#define abonent_buzy		as_bits_3.bit03
/*   */
#define abonent_faulty		as_bits_3.bit02
/*    */
#define ctrl_interfice		as_bits_3.bit01
/*   */
#define terminal_faulty		as_bits_3.bit00

/*    */
#ifdef MY_DRIVER_BIG_ENDIAN
typedef union mmr_reg_word_mntr
{
	u_short		  wr_mmr_reg_word_mntr;
	struct
		{
			u_short  bit15  : 1;
			u_short  bit14  : 1;
			u_short  bit13  : 1;
			u_short  bit12  : 1;
			u_short  bit11  : 1;
			u_short  bit10 	: 1;
			u_short  bit09  : 1;
			u_short  bit08  : 1;
			u_short  bit07  : 1;
			u_short  bit06  : 1;
			u_short  bit05  : 1;
			u_short  bit04  : 1;
			u_short  bit03 	: 1;
			u_short  bit02  : 1;
			u_short  bit01  : 1;
			u_short  bit00  : 1;
		} as_bits_4;
} mmr_reg_word_mntr_t;
#else
typedef union mmr_reg_word_mntr
{
	u_short		  wr_mmr_reg_word_mntr;
	struct
		{
			u_short  bit00  : 1;
			u_short  bit01  : 1;
			u_short  bit02  : 1;
			u_short  bit03  : 1;
			u_short  bit04  : 1;
			u_short  bit05  : 1;
			u_short  bit06 	: 1;
			u_short  bit07  : 1;
			u_short  bit08  : 1;
			u_short  bit09  : 1;
			u_short  bit10  : 1;
			u_short  bit11  : 1;
			u_short  bit12  : 1;
			u_short  bit13 	: 1;
			u_short  bit14  : 1;
			u_short  bit15  : 1;
		} as_bits_4;
} mmr_reg_word_mntr_t;
#endif /* MY_DRIVER_BIG_ENDIAN */

/*    
#define command_fulfill			as_bits_4.bit15 */
/*     800  */
#define command_not_carr		as_bits_4.bit14 
/*       */
#define serve_not_demand		as_bits_4.bit13
/*   
#define command_carr_out 		as_bits_4.bit12 */
/*        */
/*      */
#define term_output_reciv_word  as_bits_4.bit11
/*  -  */
#define reciv_trans				as_bits_4.bit10
/*   */
#define error_parity			as_bits_4.bit09
/*        */
#define durat_impulse_not		as_bits_4.bit08
/*        */
#define durat_second_not		as_bits_4.bit07
/*        */
#define durat_first_not			as_bits_4.bit06
/*    
#define num_active_chnl			as_bits_4.bit05 */
/*       */
#define accept_inadm_comm		as_bits_4.bit04
/*          */
#define reg_datas_occup			as_bits_4.bit03
/*          */
#define reg_datas_empty			as_bits_4.bit02
/*        */
/*   */
#define accept_incorr_addr		as_bits_4.bit01
/*     . */
/*       . */
#define  not_recip_word			as_bits_4.bit00

#ifndef MMR_OLD_VERSION
/*       */
#ifdef MY_DRIVER_BIG_ENDIAN
typedef union mmr_reg_common
{
	u_int          wr_mmr_reg_common;
	struct
		{
			u_int  bit3128 : 4; /*    ,  */
								 /*      */
			u_int  bit2724 : 4; /*    ,  */
								 /*      */
			u_int  bit2319 : 5; /*    ,  */
								 /*      */
			u_int  bit1814	: 5; /*    ,  */
								 /*      */
			u_int  bit13	: 1; /* -   1 - 1  */
								 /* 0 - 2  */
			u_int  bit1206 : 7; /*       */
			u_int  bit0500 : 6; /*   */
		} as_bits_5;
} mmr_reg_common_t;
#else
typedef union mmr_reg_common
{
	u_int          wr_mmr_reg_common;
	struct
		{
			u_int  bit0500 : 6; /*   */
			u_int  bit1206 : 7; /*       */
			u_int  bit13   : 1; /* -   1 - 1 , 0 - 2  */
			u_int  bit1814 : 5; /*   ,       */
			u_int  bit2319 : 5; /*   ,       */
			u_int  bit2724 : 4; /*   ,       */
			u_int  bit3128 : 4; /*   ,       */
		} as_bits_5;
} mmr_reg_common_t;
#endif /* MY_DRIVER_BIG_ENDIAN */

/*    ,       */
#define pointer_subblock_exch  	as_bits_5.bit3128 
/*    ,       */
#define pointer_subblock_comm  	as_bits_5.bit2724
/*    ,       */
#define pointer_block_exch		as_bits_5.bit2319
/*    ,       */
#define pointer_block_comm		as_bits_5.bit1814
/* -   */
#define num_full_block			as_bits_5.bit13
/*    */
#define num_version_or_buf		as_bits_5.bit1206
#endif /* MMR_OLD_VERSION */

/* /   MR */
typedef struct arg_reg {
	int		reg_addr;	/*   */
	u_int		reg_value;	/* /  */
} mmr_arg_reg_t;

/*     */
typedef struct mmr_iosubd_desc {
	u_char	cur_num_subarray;  /*    */
	u_char	next_num_subarray; /*    */
	u_short	unused1;		   /*   */
/*   -  ()    */
	u_char	amount_words[8];
	u_short	cur_addr_subarray_del;   /*    */
	u_short	next_addr_subarray_del;  /*    */
	short	buf_num;        /*    */
	u_short io_flags; 		/*    */
	u_short data_size; 		/*       */
	short	unused5; 		/*   */
	int	unused_word6; 	/*   */
	int	unused_word7; 	/*   */
} mmr_iosubd_desc_t;

/*	    .
	          
	      .
	      
	  
*/
typedef union mmr_data_buf_ {
	u_short
								/*     */
								/*     MMR */
								/* (2 , 16 ) */
		words[TU_MMR_DMA_BURST_SIZE_ALIGN(MMR_MAX_DATA_BUF_SIZE /
				sizeof(u_short),
			sizeof(u_short), 0, MMR_DMA_BURST_SIZE)];
	u_int
								/*    */
								/*  (4  32 ) */
		longs[TU_MMR_DMA_BURST_SIZE_ALIGN(MMR_MAX_DATA_BUF_SIZE /
			sizeof(u_int), sizeof(u_int), 0,
			MMR_DMA_BURST_SIZE)];
	u_char
								/*   */
		bytes[TU_MMR_DMA_BURST_SIZE_ALIGN(MMR_MAX_DATA_BUF_SIZE,
			sizeof(u_char), 0, MMR_DMA_BURST_SIZE)];
} mmr_data_buf_t;

/*     .
	       
	   .     
	     
	 .
*/
typedef struct mmr_iosubdbuf {
	mmr_iosubd_desc_t       buf_desc;  /*     */
	mmr_data_buf_t  	data_buf;  /*      */
} mmr_iosubdbuf_t;

/*      .
	      
	     .
*/
typedef struct mmr_iomap_subd {
	mmr_iosubdbuf_t	write;  /*   */
	mmr_iosubdbuf_t	read;	/*   */

} mmr_iomap_subd_t;

/*     -    .
	      
	      .
*/
typedef mmr_iomap_subd_t		mmr_iomap_t;

/*        */
typedef struct mmr_init_iomap {
	u_short		buf_num;		/*     */
	u_short		max_data_buf_trans_size;
					/*      */
	u_short		max_data_buf_reciv_size;
					/*      */
	size_t		*real_buf_size_p;
								/*    */
								/*    */
								/*    */
								/*  c  */
								/*   */
								/*   */
	int		*error_code_p;				/*    */
								/*    , */
								/*    */
								/*    */
								/*  */
	int		flag_board;				/*  : */
								/*    */
} mmr_init_iomap_t;


/*         */
#ifdef MMR_OLD_VERSION
typedef struct mmr_halt_trans {
	int		waiting_time;		/*    */
								/*    */
								/*  ,  */
								/*    */
								/*   */
								/*  0,    */
								/*     */
								/*   */
								/*    - */
								/* ( close() ) */
								/*  < 0,   */
								/*     */
								/*    */
								/*    */
								/*    */
								/*   */
								/*  > 0,     */
								/* ,  */
								/*     */
								/*   */
} mmr_halt_trans_t;
#else
typedef struct mmr_halt_trans {
	int		waiting_time;		/*    */
								/*    */
								/*  ,  */
								/*    */
								/*   */
	hrtime_t	max_time_waiting; /* .     */
	hrtime_t	med_time_waiting; /*      */
	hrtime_t	min_time_waiting; /* .     */
	u_int       	allocation_time_intr[GISTOGR];
	hrtime_t	max_time_adapter; /* .     */
	hrtime_t	med_time_adapter; /*      */
	hrtime_t	min_time_adapter; /* .     */
	u_int       	allocation_time_adapter[GISTOGR];
	u_int		max_comm; /* . -    */
	u_int      	allocation_comm[GISTOGR_COMM];
} mmr_halt_trans_t;
#endif /* MMR_OLD_VERSION */
/*  ,       
	 .
	     ,  
	ioctl() 
*/
typedef	struct mmr_dev_info {
	int			instance;	/*  MMR */
	int			channel;	/*   */
} mmr_dev_info_t;

#ifndef MMR_OLD_VERSION
typedef struct mmr_drv_info
{
	int			sbus_clock_freq;	/*   SBus */
	int			sbus_nsec_cycle;	/*   tick- SBus */
	int			mp_clock_freq;		/*   SBus */
							/*  */
	int			mp_nsec_cycle;		/*   tick-  */
	hrtime_t    		cur_hr_time;		/*     */
}	mmr_drv_info_t;
#endif /* MMR_OLD_VERSION */

/* ,     MMRIO_INTR_TIME_WAIT */
#ifdef MMR_OLD_VERSION 
typedef struct mmr_intr_wait {
	u_long	intr_wait_time;			/*    () */
	u_long	event_intr;			/*   */
	u_long	board_error;		 	/*    */
	u_long	pointer_reciv_comm;		/*     */
						/*     */
	u_long	cur_num_comm;			/* -   */
} mmr_intr_wait_t;
#else
typedef struct mmr_intr_wait {
	u_long		intr_wait_time;			/*    () */
	u_long		event_intr;			/*   */
	u_long		board_error;		 	/*    */
	u_int		num_reciv_comm;			/* -     */
							/*    .  */
	u_int		cur_num_comm;			/* -   */
	u_int		intr_device; 			/*       */
	hrtime_t	time_get_intr_device;		/*       */
	hrtime_t	time_get_comm; 			/*       */
							/*   */
} mmr_intr_wait_t;

#endif /* MMR_OLD_VERSION */

#ifndef MMR_OLD_VERSION
/*       */
typedef struct intr_rosh
{
	u_short		num_intr_rosh;			/* -    */
} mmr_intr_rosh_t;
#endif /* MMR_OLD_VERSION */

/*    */
typedef struct buf_data {
	u_int	area_subbuf0[8];
	u_int	area_subbuf1[8];
} buf_data_t;

/*     */
typedef struct buf_args {
	u_int	USK; /*  */
	u_int	AC0; /* 0 */
	u_int	SKB; /*  */
	u_int	AC1; /* 1 */
} buf_args_t;

/*      */
typedef struct mmr_area_bozu {
	buf_data_t  /*     */
				buf_data[MMR_BUF_ADAPTER_NUM*2];
	buf_args_t  /*      */
				init_buf_data[MMR_BUF_ADAPTER_NUM*2];
	buf_data_t  /*     */
				buf_comm;
	buf_args_t  /*      */
				init_buf_comm;
} mmr_area_bozu_t;

#ifdef	__cplusplus
}
#endif

#endif	/* _LINUX_MMR_IO_H__ */
