#ifndef __USER_INTF_H__
#define __USER_INTF_H__

#ifdef	__cplusplus
extern "C" {
#endif

/* user_intf.h

	result 	reqlen acclen errno

*/


#define MAX_CHANNEL	4 /* 8 eai => MAX_CHANNEL in*/


/*
	   IOCTL-
*/
typedef struct mbkp_ioc_parm {
	size_t	reqlen;		/*    I/O 	*/
	size_t	acclen;		/*    I/O 	*/
	char	err_no;		/*  :   MBKP_E_... */ 
	char	rwmode;		/* :     IOCTL- */
} mbkp_ioc_parm_t;

/*
	 IOCTL  (   mbkp_ioc_parm.errno)
*/ 

#define MBKP_IOC_WAIT	     1 /*   			*/
#define MBKP_IOC_NOWAIT	     2 /*   			*/
#define MBKP_IOC_CHECK	     3 /*     !#k!	*/
#define MBKP_IOC_POLL	     4 /*   tr/rcv 			*/

/*
	 IOCTL 
*/ 

#define MBKP_IOC_ALLOCB	     2 /*    reqlen 		*/
#define MBKP_IOC_READ	     3 /*     	 	*/
#define MBKP_IOC_WRITE	     4 /*    reqlen 		*/
#define MBKP_TIMER_FOR_READ  5 /*    reqlen  */
#define MBKP_TIMER_FOR_WRITE 6 /*    reqlen  */
#define MBKP_IOC_DE 	     7 /*    		*/
#define MBKP_IOC_DW	     8 /*  	 		*/
#define MBKP_IOC_DR	     9 /*  	 		*/
#define MBKP_SELF_TEST	     0x99

/* ++ */
#define MBKP_IOC_SETRES	    10 /*   		*/
#define MBKP_IOC_RETMAIN    11 /*   		*/
#define MBKP_IOC_SETTRBA    12 /*   		*/
#define MBKP_IOC_WRCMD	    14 /*    reqlen		*/

#define MBKP_IOC_RDR 	    15
#define MBKP_IOC_WRR 	    16

#define MBKP_IOC_RDALT	    23 /*    2  		*/
#define MBKP_IOC_RDESCALT   29 /*    2 	*/

#define MBKP_IOC_DEBUG	    30 

#define MBKP_IOC_IOTIME     28

/*      */
/* min  MBKP_IO_FINISHED    MBKP_IOC_... */

#define MBKP_IO_FINISHED    0x0100	/*      */


/*
	     mbkp_ioc_parm_t.errno
	errno!= MBKP_E_NORMAL  
*/ 

#define MBKP_E_NORMAL 	 0 /*    	 */
#define MBKP_E_INVOP  	 1 /*     	 */
#define MBKP_E_INVAL  	 2 /*     */
#define MBKP_E_NOBUF 	 5 /*   	MBKP_IOC_ALLOCB */

#define MBKP_E_URGENT 	10 /*   readf   */
#define MBKP_E_PENDING 	11 /*     	 */
#define MBKP_E_TIMER 	12 /*     	 */	

#define MBKP_IOC_NOTRUN 14 /*     		*/ 
#define MBKP_IOC_DIFCH  15 /*      */ 
#define MBKP_DESC_DISABLED 16 /*       ~ */

#define MBKP_ERREAD  20 /*      0 */
#define MBKP_ERWRITE 21 /*    		 */

#define MBKP_ERREAD1 30 /*      1 */


struct code_msg {
	int code;
	char * msg;
};

typedef struct code_msg code_msg_t; 

code_msg_t iocerrs[] = {
	{MBKP_E_INVOP, "MBKP_E_INVOP"},
	{MBKP_E_INVAL, "MBKP_E_INVAL"},
	{MBKP_E_NOBUF, "MBKP_E_NOBUF"},
	
	{MBKP_E_PENDING, "MBKP_E_PENDING"},
	{MBKP_E_TIMER, "MBKP_E_TIMER"},
	{MBKP_DESC_DISABLED, "MBKP_DESC_DISABLED"},
	{MBKP_IOC_DIFCH, "MBKP_IOC_DIFCH"},
	{MBKP_IOC_NOTRUN, "MBKP_IOC_NOTRUN"},
	{MBKP_ERREAD, "MBKP_ERREAD"},
	{MBKP_ERREAD1, "MBKP_ERREAD1"},
	{MBKP_ERWRITE, "MBKP_ERWRITE"},
	{MBKP_E_URGENT, "MBKP_E_URGENT"},
};

code_msg_t ioctls[] = {
	{MBKP_TIMER_FOR_READ, "MBKP_TIMER_FOR_READ"}, 
	{MBKP_TIMER_FOR_WRITE, "MBKP_TIMER_FOR_WRITE"},
	{MBKP_IOC_ALLOCB, "MBKP_IOC_ALLOCB"},
	{MBKP_IOC_READ, "MBKP_IOC_READ"},
	{MBKP_IOC_WRITE, "MBKP_IOC_WRITE"},
	{MBKP_IOC_DE, "MBKP_IOC_DE"},
	{MBKP_IOC_DW, "MBKP_IOC_DW"},
	{MBKP_IOC_RDR, "MBKP_IOC_RDR"},
	{MBKP_IOC_WRR, "MBKP_IOC_WRR"},
	
};

code_msg_t rwmods[] = {
	{MBKP_IOC_WAIT, "MBKP_IOC_WAIT"}, 
	{MBKP_IOC_NOWAIT, "MBKP_IOC_NOWAIT"},
	{MBKP_IOC_CHECK, "MBKP_IOC_CHECK"},
	{MBKP_IOC_POLL, "MBKP_IOC_POLL"},
};

char * msg_by_code (int code, code_msg_t * v, int len) {
	code_msg_t * p;
	int i;
	for (i=0; i < len ; i++) {
		p = v + i;
		if (p->code == code) 
			return p->msg;
	}
	return " code=? ";
}

#ifdef	__cplusplus
}
#endif

#endif /* __USER_INTF_H__ */
